// nGL.cpp: nGL NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BirdEye.h"
#include "nGL.h"
#include "nMessage.h"
#include "nInputDialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

istream& operator>>(istream& is,CString& str)
{
	const int BUFFER_SIZE = 40; //悭gRg1s炢Ƃ̂悭Ȃ͂
	char buf[BUFFER_SIZE];
	char sep = '\n';
	int cur_len = 0;
	char* cur_string=NULL;
	char* new_string=NULL;
	is >> ws;
	while(is.peek() != sep && !(is.eof())){
		is.get(buf,BUFFER_SIZE,sep);
		cur_len=cur_len+strlen(buf);
		new_string=new char[cur_len+1];
		if(cur_string){
			strcpy(new_string,cur_string);
			delete[] cur_string;
		}else{
			*new_string='\0';
		}
		strcat(new_string,buf);
		cur_string=new_string;
	}
	is.get();
	str=cur_string;
	if(new_string){
		delete new_string;
	}
	return is;
}

ostream& operator<<(ostream& os,CString& str)
{
	os<<str.operator LPCTSTR();
	return os;
}


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

nGL::nGL()
{

}

nGL::~nGL()
{

}

//---------------------------------------
#define IDLE 0
//---------------------------------------

#define THIS_LIST 1

#define COMMENT_START '/'

//--------------------------------
// staticȃf[^̗̈m

GLint nGL::window_width,nGL::window_height;

GLfloat nGL::radius;
GLint   nGL::theta,nGL::phi;
GLfloat nGL::origin_x,nGL::origin_y,nGL::origin_z;

const GLfloat  nGL::PI          = acos(-1.0);
const GLdouble nGL::const_angle = 180.0/PI;

CString nGL::flowerString,nGL::leafString,nGL::edgeString,nGL::seedString;
GLint nGL::flowerNumber,nGL::leafNumber,nGL::edgeNumber,nGL::seedNumber;

GLdouble nGL::field_min_x,nGL::field_max_x,
		nGL::field_min_y,nGL::field_max_y,
		nGL::field_center_x,nGL::field_center_y,
		nGL::field_haba;

GLdouble nGL::field_length,nGL::edge_radius;

//--------------------------------

void nGL::idle()
{
	if(glutLayerGet(GLUT_NORMAL_DAMAGED)!=0){
		//Xy[X
		return;
	}
	phi += 5;
	if(phi>360){
		phi =0;
	}
	glutPostRedisplay();
}

void nGL::makeColor(const GLfloat red,const GLfloat green,const GLfloat blue,GLfloat ambient)
{
	const GLfloat const_ambient = 0.50;
	if(ambient<0.0){
		ambient = const_ambient;
	}

	GLfloat diffuse_color[4],ambient_color[4];

	diffuse_color[_red]   = red* ambient;
	ambient_color[_red]   = red ;
	diffuse_color[_green] = green* ambient;
	ambient_color[_green] = green ;
	diffuse_color[_blue]  = blue* ambient;
	ambient_color[_blue]  = blue ;
	diffuse_color[_alpha] = 1.0; //alphal
	ambient_color[_alpha] = 1.0; //alphal

	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,diffuse_color);
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,ambient_color);

}

void nGL::makeField()
{
	glPushMatrix();
	makeColor(0.70,0.50,0.30);

	GLdouble copy_min_x = field_min_x;
	GLdouble copy_min_y = field_min_y;
	GLdouble copy_max_x = field_max_x;
	GLdouble copy_max_y = field_max_y;
	GLdouble copy_center_x = field_center_x;
	GLdouble copy_center_y = field_center_y;
	
	convert_x(&copy_min_x);
	convert_y(&copy_min_y);
	convert_x(&copy_max_x);
	convert_y(&copy_max_y);
	convert_x(&copy_center_x);
	convert_y(&copy_center_y);

	glBegin(GL_POLYGON);
		glNormal3d(0.0,0.0,1.0);
		glVertex3d(copy_min_x,copy_min_y,0.0);
		glVertex3d(copy_max_x,copy_min_y,0.0);
		glVertex3d(copy_max_x,copy_max_y,0.0);
		glVertex3d(copy_min_x,copy_max_y,0.0);
	glEnd();

	glPopMatrix();
}

void nGL::makeEdge(const GLdouble start[3],const GLdouble end[3])
{
	glPushMatrix();

	double rand_red = (double)rand()/(double)RAND_MAX;
	double rand_green = (double)rand()/(double)RAND_MAX;
	double rand_blue = (double)rand()/(double)RAND_MAX;

	GLfloat diffuse_color[4],ambient_color[4],specular_color[4];

	diffuse_color[_red]   = 0.01;
	diffuse_color[_green] = 0.01;
	diffuse_color[_blue]  = 0.01;
	diffuse_color[_alpha] = 1.00;

	ambient_color[_red]   = 0.30+0.20*rand_red;
	ambient_color[_green] = 0.15+0.05*rand_green;
	ambient_color[_blue]  = 0.00+0.05*rand_blue;
	ambient_color[_alpha] = 1.00;

	specular_color[_red]   = 0.00;
	specular_color[_green] = 0.00;
	specular_color[_blue]  = 0.00;
	specular_color[_alpha] = 1.00;

	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,diffuse_color);
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,ambient_color);
//	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,specular_color);


	GLdouble center[3];
	GLdouble aim[3];


	center[_x] = (start[_x]+end[_x])/2.0;
	center[_y] = (start[_y]+end[_y])/2.0;
	center[_z] = (start[_z]+end[_z])/2.0;

	aim[_x] = -start[_x]+end[_x];
	aim[_y] = -start[_y]+end[_y];
	aim[_z] = -start[_z]+end[_z];

	GLdouble length = sqrt(
			aim[_x]*aim[_x] + aim[_y]*aim[_y] + aim[_z]*aim[_z]);

	//Ƃ肠S_Ɉړ
	glTranslated(center[_x],center[_y],center[_z]);


	//S_𒆐Sɉ]
	glRotated(acos(aim[_z] / length) * nGL::const_angle ,-aim[_y],aim[_x],0.0);

	//ŌɊg
	glScaled(edge_radius,edge_radius,length);

	//łɕ`
	glutSolidCube(1.0);

	glPopMatrix();
}

void nGL::makeFlower(const GLdouble center[3],const GLdouble seed[3],const GLdouble r)
{
	glPushMatrix();

	GLdouble aim[3];

	aim[_x] = -center[_x]+seed[_x];
	aim[_y] = -center[_y]+seed[_y];
	aim[_z] = -center[_z]+seed[_z];

	GLdouble length = sqrt(
			aim[_x]*aim[_x] + aim[_y]*aim[_y] + aim[_z]*aim[_z]);

	//Ƃ肠V[h_Ɉړ
	glTranslated(center[_x],center[_y],center[_z]);

	//V[h_𒆐Sɉ]
	glRotated(acos(aim[_z] / length) * const_angle ,-aim[_y],aim[_x],0.0);

	//ŌɊg
	glScaled(r,r,r);

	//łɕ`
	makeColor(1.0,1.0,0.0);
	glutSolidSphere(1.0,10,10);

	makeColor(1.0,0.0,0.0);

		glPushMatrix();
		glTranslatef(1.50,0.0,0.0);
		glutSolidSphere(0.50,10,10);
		glPopMatrix();

		glPushMatrix();
		glTranslatef(-1.50,0.0,0.0);
		glutSolidSphere(0.50,10,10);
		glPopMatrix();

		glPushMatrix();
		glTranslatef(0.0,-1.50,0.0);
		glutSolidSphere(0.50,10,10);
		glPopMatrix();

		glPushMatrix();
		glTranslatef(0.0,1.50,0.0);
		glutSolidSphere(0.50,10,10);
		glPopMatrix();

	glPopMatrix();

}

void nGL::makeLeaf(const GLdouble center[3],const GLdouble seed[3],const GLdouble r)
{
	glPushMatrix();

	GLdouble aim[3];

	aim[_x] = -center[_x]+seed[_x];
	aim[_y] = -center[_y]+seed[_y];
	aim[_z] = -center[_z]+seed[_z];

	GLdouble length = sqrt(
			aim[_x]*aim[_x] + aim[_y]*aim[_y] + aim[_z]*aim[_z]);

	//Ƃ肠V[h_Ɉړ
	glTranslated(center[_x],center[_y],center[_z]);

	//V[h_𒆐Sɉ]
	glRotated(acos(aim[_z] / length) * const_angle ,-aim[_y],aim[_x],0.0);

	//ŌɊg
	glScaled(r,r,r);

	double rand_red = (double)rand()/(double)RAND_MAX;
	double rand_green = (double)rand()/(double)RAND_MAX;
	double rand_blue = (double)rand()/(double)RAND_MAX;

	rand_red = 0.0+0.05*rand_red;
	rand_green = 0.15+0.2*rand_green;
	rand_blue = 0.0+0.075*rand_blue;

	//łɕ`
	makeColor(rand_red,rand_green,rand_blue);
	glutSolidSphere(1.0,10,10);

	glPopMatrix();

}

void nGL::makeAxisList()
{

	glPushMatrix();

		glBegin(GL_LINES);
			glColor3f(1.0,0.0,0.0);
			glVertex3f(4.0,0.0,0.0);
			glVertex3f(-2.0,0.0,0.0);
		glEnd();
		glBegin(GL_LINES);
			glColor3f(0.0,1.0,0.0);
			glVertex3f(0.0,4.0,0.0);
			glVertex3f(0.0,-2.0,0.0);
		glEnd();
		glBegin(GL_LINES);
			glColor3f(0.0,0.0,1.0);
			glVertex3f(0.0,0.0,4.0);
			glVertex3f(0.0,0.0,-2.0);
		glEnd();

		//glColor3f(1.0,1.0,1.0);
		//glutWireCube(2.0/0.5);

	glPopMatrix();
	
}

void nGL::makeList(const CString& fileName)
{
	glNewList(THIS_LIST,GL_COMPILE);

	initLight();

	GLfloat mat_ambient[] = {1.0,1.0,1.0,1.0};
	GLfloat mat_specular[] = {0.0,0.0,0.0,1.0};
	GLfloat shininess[] = {0.0};

	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambient);
	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat_specular);
	glMaterialfv(GL_FRONT_AND_BACK,GL_SHININESS,shininess);

	//------------------------------------
	//ƃt@CłĂ݂悤
	//------------------------------------
	
	ifstream is(fileName.operator LPCTSTR());

	CString readString;
	do{
		is >> readString;
	}while(is.good() && (readString.GetLength() == 0 ||readString.GetAt(0) == COMMENT_START));

	readField(readString.operator LPCTSTR());
	while(is.good()){
		do{
			is >> readString;
		}while(is.good() && (readString.GetLength() == 0 ||readString.GetAt(0) == COMMENT_START));
		if(is.fail()){
			break;
		}
		const char* tmpString = readString.operator LPCTSTR();
		switch(tmpString[0]){
		case 'F':
			readFlower(tmpString);
			break;
		case 'L':
			readLeaf(tmpString);
			break;
		case 'E':
			readEdge(tmpString);
			break;
		case 'S':
			readSeed(tmpString);
			break;
		default:
			ASSERT(0);
			//ɂ̂͂
			break;
		}
	}	
	is.close();

	//------------------------------------
	//ƃt@CłĂ݂悤
	//------------------------------------

	glDisable(GL_LIGHTING);
	makeAxisList();

	glEndList();
}

void nGL::initLight()
{
	GLfloat light_ambient[] = {1.0,1.0,1.0,1.0};
	GLfloat light_diffuse[] = {1.0,1.0,1.0,1.0};
	GLfloat light_specular[]= {1.0,1.0,1.0,1.0};
	GLfloat light_position[]= {0.0,0.0,1.0,0.0}; //z̓̕

	glLightfv(GL_LIGHT0,GL_AMBIENT,light_ambient);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,light_diffuse);
	glLightfv(GL_LIGHT0,GL_SPECULAR,light_specular);
	glLightfv(GL_LIGHT0,GL_POSITION,light_position);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

}


void nGL::init()
{
	srand( (unsigned)time( NULL ) );

	origin_x = origin_y = origin_z = 0.0;
	radius = 10.0;
	theta = 60;
	phi = 70;

	flowerString = "";
	leafString   = "";
	edgeString   = "";
	seedString   = "";
	flowerNumber = leafNumber = 
		edgeNumber = seedNumber = 0;


	field_min_x  = field_max_x =
		field_min_y = field_max_y = 
		field_center_x = field_center_y = 
		field_haba = 0.0; //dummy initialize

	field_length = edge_radius = 0.0; //dummy initialize
	
	glClearColor(0.0,0.0,0.0,0.0);

	initLight();

}

void nGL::display()
{
#if IDLE
	if(glutLayerGet(GLUT_NORMAL_DAMAGED)!=0){
		//Xy[X
		return;
	}
#endif

	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();

	GLfloat cos_theta = cos(theta / const_angle);
	GLfloat sin_theta = sin(theta / const_angle);
	GLfloat cos_phi   = cos(phi / const_angle);
	GLfloat sin_phi   = sin(phi / const_angle);

	GLfloat coor1[3],coor2[3];

	coor1[_x] = radius*sin_theta*cos_phi;
	coor1[_y] = radius*sin_theta*sin_phi;
	coor1[_z] = radius*cos_theta;

	//coor1 Ɓ@coor2łphi/QႤɂȂ
	coor2[_x] = -cos_theta*cos_phi;
	coor2[_y] = -cos_theta*sin_phi;
	coor2[_z] = sin_theta;

	gluLookAt(origin_x+coor1[_x],origin_y+coor1[_y],origin_z+coor1[_z],
		origin_x,origin_y,origin_z,
		coor2[_x],coor2[_y],coor2[_z]);

	glCallList(THIS_LIST);

	glPopMatrix();

	glFlush();
	glutSwapBuffers();

	glDisable(GL_DEPTH_TEST);
}

void nGL::reshape(int width,int height)
{
	glViewport(0,0,width,height);
	window_width = width;
	window_height = height;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(20.0,(GLfloat)width/(GLfloat)height,1.0,40.0);
	glMatrixMode(GL_MODELVIEW);

	glLoadIdentity();
	glTranslatef(0.0,0.0,-10.0);
}

void nGL::specialkey(int key,int x,int y)
{
	switch(key){
	case GLUT_KEY_UP:
		theta +=5 ;
		break;
	case GLUT_KEY_DOWN:
		theta -= 5;
		break;
	case GLUT_KEY_LEFT:
		phi +=5 ;
		break;
	case GLUT_KEY_RIGHT:
		phi -=5 ;
		break;
	default:
		break;
	}

	glutPostRedisplay();
}

void nGL::mouse(int button,int state,int x,int y)
{
	if(state == GLUT_DOWN){
		switch(button){
		case GLUT_LEFT_BUTTON:
			saveBMPFile();
			break;
		case GLUT_RIGHT_BUTTON:
			makeInputDialog();
			break;
		default:
			break;
		}
	}
}
void nGL::keyboard(unsigned char key, int x,int y)
{
	switch(key){
	case 27: //ESC
		exit(0);
		break;
	case 'b':
	case 'B':
		saveBMPFile();
		break;
	case 'f':
	case 'F':
		readFile();
		break;
	case 'd':
	case 'D':
		makeInputDialog();
		break;
	case '9':
		radius += 1.0;
		break;
	case '1':
		radius -= 1.0;
		break;
	case '2':
		origin_x -= 1.0;
		break;
	case '8':
		origin_x += 1.0;
		break;
	case '3':
		origin_y -= 1.0;
		break;
	case '7':
		origin_y += 1.0;
		break;
	case '4':
		origin_z -= 1.0;
		break;
	case '6':
		origin_z += 1.0;
	default:
		break;
	}

	if(radius<-1.0){
		radius=-1.0;
	}

	if(theta < 0){
		theta += 360;
	}else if(theta>360){
		theta -= 360;
	}

	if(phi < 0){
		phi += 360;
	}else if(phi>360){
		phi -= 360;
	}

	glutPostRedisplay();
}

int nGL::nGLmain(int argc,char** argv)
{
	if(AfxMessageBox("ǂݍ݃t@C肵܂",MB_YESNO)==IDNO){
		return -1;
	}

	char* filename = initFile();

	if(filename==NULL){
		return -1;
	}

	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_RGBA| GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowPosition(50,50);
	glutInitWindowSize(300,300);

	char* title = new char[20+strlen(filename)];
	strcpy(title,"BirdEye::");
	strcat(title,filename);
	glutCreateWindow(title);
	delete[] title;

	nMessage message(CString("t@Cǂݍݒ::")+filename);
	init();
	makeList(filename);
	message.close();

	delete[] filename;

	glutSpecialFunc(specialkey);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouse);

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);

#if IDLE
	glutIdleFunc(idle);
#endif

	glutMainLoop();
	return 0;
}

void nGL::readFlower(const char* lineString)
{
	char c;
	GLdouble center[3],seed[3];
	GLdouble r;
	char tmpIDString[100]; //100炢ƂΏ\ł傤
	sscanf(lineString,
		"%c %lf %lf %lf %lf %lf %lf %lf %s",
		&c ,&center[_x] , &center[_y], &center[_z],
		&r, &seed[_x]   , &seed[_y]  , &seed[_z],
		tmpIDString);
	//f[^ǂݍ݊
	CString addString;
	addString.Format("%.2lf,%.2lf,%.2lf,%.2lf,%s",
		center[_x],center[_y],center[_z],
		r,tmpIDString);
	flowerString += addString + "\x0d\x0a";
	++flowerNumber;
	//ŃXg̍쐬
	//łcenter,seedĂ悢B
	convert_x(&center[_x]);
	convert_x(&seed[_x]);
	convert_y(&center[_y]);
	convert_y(&seed[_y]);
	convert_z(&center[_z]);
	convert_z(&seed[_z]);
	convert_z(&r);


	makeFlower(center,seed,r);
}

void nGL::readLeaf(const char* lineString)
{
	char c;
	GLdouble center[3],seed[3];
	GLdouble r;
	char tmpIDString[100]; //100炢ƂΏ\ł傤
	sscanf(lineString,
		"%c %lf %lf %lf %lf %lf %lf %lf %s",
		&c ,&center[_x] , &center[_y], &center[_z],
		&r, &seed[_x]   , &seed[_y]  , &seed[_z],
		tmpIDString);
	//f[^ǂݍ݊
	CString addString;
	addString.Format("%.2lf,%.2lf,%.2lf,%.2lf,%s",
		center[_x],center[_y],center[_z],
		r,tmpIDString);
	leafString += addString + "\x0d\x0a";
	++leafNumber;
	//ŃXg̍쐬
	//łcenter,seedĂ悢B
	convert_x(&center[_x]);
	convert_x(&seed[_x]);
	convert_y(&center[_y]);
	convert_y(&seed[_y]);
	convert_z(&center[_z]);
	convert_z(&seed[_z]);
	convert_z(&r);

	makeLeaf(center,seed,r);
}

void nGL::readEdge(const char* lineString)
{
	char c;
	GLdouble start[3],end[3];

	char tmpIDString[100]; //100炢ƂΏ\ł傤
	sscanf(lineString,
		"%c %lf %lf %lf %lf %lf %lf %s",
		&c ,&start[_x] , &start[_y], &start[_z],
		    &end[_x]   , &end[_y]  , &end[_z],
		tmpIDString);
	//f[^ǂݍ݊
	CString addString;
	addString.Format("%.2lf,%.2lf,%.2lf,%.2lf,%.2lf,%.2lf,%s",
		start[_x],start[_y],start[_z],
		end[_x],  end[_y],  end[_z],
		tmpIDString);
	edgeString += addString + "\x0d\x0a";
	++edgeNumber;
	//ŃXg̍쐬
	//łstart,endĂ悢B
	convert_x(&start[_x]);
	convert_x(&end[_x]);
	convert_y(&start[_y]);
	convert_y(&end[_y]);
	convert_z(&start[_z]);
	convert_z(&end[_z]);


	makeEdge(start,end);
}

void nGL::readSeed(const char* lineString)
{
	char c;
	GLdouble seed[3];

	char tmpIDString[100]; //100炢ƂΏ\ł傤
	sscanf(lineString,
		"%c %lf %lf %lf %s",
		&c ,&seed[_x]   , &seed[_y]  , &seed[_z],
		tmpIDString);
	//f[^ǂݍ݊
	CString addString;
	addString.Format("%.2lf,%.2lf,%.2lf,%s",
		seed[_x],seed[_y],seed[_z],
		tmpIDString);
	seedString += addString + "\x0d\x0a";
	++seedNumber;
	//ŃXg̍쐬
	//̓łcenter,seedĂ悢B
	convert_x(&seed[_x]);
	convert_y(&seed[_x]);
	convert_z(&seed[_x]);
	//V[h͂ǂĕ\悤

}

void nGL::readField(const char *lineString)
{
	sscanf(lineString,
		"%lf %lf %lf %lf %lf %lf %lf",
		&field_min_x    ,&field_min_y ,
		&field_max_x    ,&field_max_y ,
		&field_center_x ,&field_center_y,
		&field_haba);

	if(field_min_x > field_max_x){
		GLdouble tmp = field_min_x;
		field_min_x = field_max_x;
		field_max_x = tmp;
	}

	if(field_min_y > field_max_y){
		GLdouble tmp = field_min_y;
		field_min_y = field_max_y;
		field_max_y = tmp;
	}


	field_length = max(
		(field_max_x - field_min_x),
		(field_max_y - field_min_y))
			/5.0;
	edge_radius = 0.45 / field_length;

	makeField();
}

void nGL::convert_x(GLdouble* value)
{
	*value =  (*value - field_center_x)/field_length;
}

void nGL::convert_y(GLdouble* value)
{
	*value =  (*value - field_center_y)/field_length;
}

void nGL::convert_z(GLdouble* value)
{
	*value =  (*value)/field_length;
}

void nGL::convert_x(GLfloat* value)
{
	*value =  (*value - field_center_x)/field_length;
}

void nGL::convert_y(GLfloat* value)
{
	*value =  (*value - field_center_y)/field_length;
}

void nGL::convert_z(GLfloat* value)
{
	*value =  (*value)/field_length;
}

GLdouble nGL::re_convert_x(GLdouble value)
{
	return value * field_length + field_center_x;
}

GLdouble nGL::re_convert_y(GLdouble value)
{
	return value * field_length + field_center_y;
}

GLdouble nGL::re_convert_z(GLdouble value)
{
	return value * field_length;
}


void nGL::saveBMPFile()
{
	CFileDialog fileDialog(false,"bmp","birdeye.bmp",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Windows Bitmap Files (*.bmp)|*.bmp||",NULL);
	char lpBuffer[_MAX_PATH];
	GetCurrentDirectory(_MAX_PATH,lpBuffer);
	CString executePath = lpBuffer;
	CString initialPath = executePath+'\\';
	fileDialog.m_ofn.lpstrInitialDir = initialPath;
	if(fileDialog.DoModal()!=IDOK){
		return;
	}
	CString filename = fileDialog.GetPathName();

	const int width = window_width - window_width%4; //̃TCY4̔{ɒ
	const int height = window_height;

	char* pixels = NULL;
	pixels = new char[(width+1) * (height+1) * 3];

	nMessage message(CString("BMPt@Cۑ::")+filename);
	glReadPixels(0,0,width,height,
		GL_RGB,GL_UNSIGNED_BYTE,pixels);
		//OpenGL̓ǂݍ

	ofstream os(filename.operator LPCTSTR(),ios::out | ios::binary);

	BITMAPFILEHEADER bitmapFileHeader;
	BITMAPINFOHEADER bitmapInfoHeader;
	const int size = width*height;
	const int fileLength = sizeof(BITMAPFILEHEADER)
				+ sizeof(BITMAPINFOHEADER)
				+ sizeof(char)*3*size;
	
	bitmapFileHeader.bfType = 'B'+'M'*256; //GfBAœւ
	bitmapFileHeader.bfSize = fileLength;
	bitmapFileHeader.bfReserved1 = 0;
	bitmapFileHeader.bfReserved2 = 0;
	bitmapFileHeader.bfOffBits = sizeof(BITMAPFILEHEADER)
				+ sizeof(BITMAPINFOHEADER);

	bitmapInfoHeader.biSize = sizeof(BITMAPINFOHEADER);
	bitmapInfoHeader.biWidth = width;
	bitmapInfoHeader.biHeight = height;
	bitmapInfoHeader.biPlanes = 1;
	bitmapInfoHeader.biBitCount = 24;
	bitmapInfoHeader.biCompression = BI_RGB;
	bitmapInfoHeader.biSizeImage = 0;
	bitmapInfoHeader.biXPelsPerMeter = 0;
	bitmapInfoHeader.biYPelsPerMeter = 0;
	bitmapInfoHeader.biClrUsed = 0;
	bitmapInfoHeader.biClrImportant = 0;

	os.write((char*)&bitmapFileHeader,sizeof(BITMAPFILEHEADER));
	os.write((char*)&bitmapInfoHeader,sizeof(BITMAPINFOHEADER));
	
	int i;

	char* point = pixels;
	for(i = 0 ; i < width * height ; ++i){
		char tmp = point[0];
		point[0] = point[2];
		point[2] = tmp;
		point += 3;
	}

	for(i = 0 ; i<height ; ++i){
		char* point = pixels + i * width * 3;
		os.write(point,width * 3);
	}

	os.close();

	if(pixels){
		delete[] pixels;
	}
	message.close();
}

void nGL::makeInputDialog()
{
	nInputDialog inputDialog;
	inputDialog.DoModal();
	glutPostRedisplay();
}


void nGL::readFile()
{
	if(AfxMessageBox("łɓǂݍłt@C̃f[^ĐVt@Cǂݍ݂܂",MB_YESNO)==IDNO){
		return;
	}
	CFileDialog fileDialog(true,"view","*.view",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Bird Eye Files (*.view)|*.view||",NULL);
	char lpBuffer[_MAX_PATH];
	GetCurrentDirectory(_MAX_PATH,lpBuffer);
	CString executePath = lpBuffer;
	CString initialPath = executePath+'\\';
	fileDialog.m_ofn.lpstrInitialDir = initialPath;

	if(fileDialog.DoModal()!=IDOK){
		return;
	}
	CString filename = fileDialog.GetPathName();

	nMessage message(CString("t@Cǂݍݒ::")+filename);
	init();
	makeList(filename);
	message.close();
	glutPostRedisplay();
}

char* nGL::initFile()
{
	CFileDialog fileDialog(true,"view","*.view",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Bird Eye Files (*.view)|*.view||",NULL);
	char lpBuffer[_MAX_PATH];
	GetCurrentDirectory(_MAX_PATH,lpBuffer);
	CString executePath = lpBuffer;
	CString initialPath = executePath+'\\';
	fileDialog.m_ofn.lpstrInitialDir = initialPath;

	if(fileDialog.DoModal()!=IDOK){
		return NULL;
	}
	CString filename = fileDialog.GetPathName();
	char* returnname = new char[filename.GetLength()+1];
	strcpy(returnname,filename.operator LPCTSTR());
	return returnname; //nGLmainłƏ
}