// nGL.h: nGL NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NGL_H__AA000117_6654_11D4_A00F_DC295C4E1733__INCLUDED_)
#define AFX_NGL_H__AA000117_6654_11D4_A00F_DC295C4E1733__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class nGL  
{
public:
	static GLint window_width,window_height;

	static GLfloat radius;
	static GLint theta,phi;
	static GLfloat origin_x,origin_y,origin_z;
	static const GLfloat PI;
	static const GLdouble const_angle;

	static CString flowerString,leafString,edgeString,seedString;

	static GLdouble field_min_x,field_max_x,
		field_min_y,field_max_y,
		field_center_x,field_center_y,
		field_haba;

	static GLdouble field_length,edge_radius;

	static GLint flowerNumber,leafNumber,edgeNumber,seedNumber;

	static int nGLmain(int argc,char** argv);

	static void convert_x(GLdouble* value);
	static void convert_y(GLdouble* value);
	static void convert_z(GLdouble* value);

	static void convert_x(GLfloat* value);
	static void convert_y(GLfloat* value);
	static void convert_z(GLfloat* value);

	static GLdouble re_convert_x(GLdouble value);
	static GLdouble re_convert_y(GLdouble value);
	static GLdouble re_convert_z(GLdouble value);

	nGL();
	virtual ~nGL();

private:
	enum {_x = 0,_y = 1,_z = 2};
	enum {_red = 0,_green = 1,_blue = 2,_alpha = 3};

	static void display();
	static void idle();
	static void reshape(int width,int height);
	static void specialkey(int key,int x,int y);
	static void keyboard(unsigned char key, int x,int y);
	static void mouse(int button,int state,int x,int y);

	static void makeColor(const GLfloat red,const GLfloat green,const GLfloat blue,GLfloat ambient = -1.0);

	static void makeAxisList();

	static void makeList(const CString& fileName);
	static void readFile();

	static void initLight();
	static void init();

	static void makeField();
	static void makeEdge(const GLdouble start[3],const GLdouble end[3]);
	static void makeFlower(const GLdouble center[3],const GLdouble seed[3],const GLdouble r);
	static void makeLeaf(const GLdouble center[3],const GLdouble seed[3],const GLdouble r);

	static void readFlower(const char* lineString);
	static void readLeaf(const char* lineString);
	static void readEdge(const char* lineString);
	static void readSeed(const char* lineString);

	static void readField(const char* lineString);

	static void saveBMPFile();
	static void makeInputDialog();

	static char* initFile();
};

istream& operator>>(istream& is,CString& str); //CStringistream̊Ԃ󂯎
ostream& operator<<(ostream& os,CString& str); //CStringostream̊Ԃ󂯎

#endif // !defined(AFX_NGL_H__AA000117_6654_11D4_A00F_DC295C4E1733__INCLUDED_)
