// nInputDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "BirdEye.h"
#include "nInputDialog.h"
#include "nGL.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// nInputDialog _CAO


nInputDialog::nInputDialog(CWnd* pParent /*=NULL*/)
	: CDialog(nInputDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(nInputDialog)
	m_edit_number = 0;
	m_edit_string = _T("");
	m_max_x = 0.0;
	m_height = 0;
	m_haba = 0;
	m_center_y = 0.0;
	m_center_x = 0.0;
	m_max_y = 0.0;
	m_min_x = 0.0;
	m_min_y = 0.0;
	m_origin_x = 0.0;
	m_origin_y = 0.0;
	m_phi = 0;
	m_radius = 0.0f;
	m_theta = 0;
	m_width = 0;
	m_origin_z = 0.0;
	//}}AFX_DATA_INIT
}


void nInputDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(nInputDialog)
	DDX_Control(pDX, IDC_COMBO_SELECT, m_combo_select);
	DDX_Text(pDX, IDC_EDIT_NUMBER, m_edit_number);
	DDX_Text(pDX, IDC_EDIT_STRING, m_edit_string);
	DDX_Text(pDX, IDC_EDIT_MAX_X, m_max_x);
	DDX_Text(pDX, IDC_EDIT_HEIGHT, m_height);
	DDX_Text(pDX, IDC_EDIT_HABA, m_haba);
	DDX_Text(pDX, IDC_EDIT_CENTER_Y, m_center_y);
	DDX_Text(pDX, IDC_EDIT_CENTER_X, m_center_x);
	DDX_Text(pDX, IDC_EDIT_MAX_Y, m_max_y);
	DDX_Text(pDX, IDC_EDIT_MIN_X, m_min_x);
	DDX_Text(pDX, IDC_EDIT_MIN_Y, m_min_y);
	DDX_Text(pDX, IDC_EDIT_ORIGIN_X, m_origin_x);
	DDV_MinMaxDouble(pDX, m_origin_x, -10000., 10000.);
	DDX_Text(pDX, IDC_EDIT_ORIGIN_Y, m_origin_y);
	DDV_MinMaxDouble(pDX, m_origin_y, -10000., 10000.);
	DDX_Text(pDX, IDC_EDIT_PHI, m_phi);
	DDV_MinMaxInt(pDX, m_phi, 0, 360);
	DDX_Text(pDX, IDC_EDIT_RADIUS, m_radius);
	DDV_MinMaxFloat(pDX, m_radius, 0.f, 100.f);
	DDX_Text(pDX, IDC_EDIT_THETA, m_theta);
	DDV_MinMaxInt(pDX, m_theta, 0, 360);
	DDX_Text(pDX, IDC_EDIT_WIDTH, m_width);
	DDX_Text(pDX, IDC_EDIT_ORIGIN_Z, m_origin_z);
	DDV_MinMaxDouble(pDX, m_origin_z, -10000., 10000.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(nInputDialog, CDialog)
	//{{AFX_MSG_MAP(nInputDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_SELECT, OnSelchangeComboSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// nInputDialog bZ[W nh

void nInputDialog::OnSelchangeComboSelect() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	const int index = m_combo_select.GetCurSel();
	if(index == CB_ERR){
		return;
	}
	switch(index){
	case 0:
		m_edit_string = nGL::edgeString;
		m_edit_number = nGL::edgeNumber;
		break;
	case 1:
		m_edit_string = nGL::leafString;
		m_edit_number = nGL::leafNumber;
		break;
	case 2:
		m_edit_string = nGL::flowerString;
		m_edit_number = nGL::flowerNumber;
		break;
	case 3:
		m_edit_string = nGL::seedString;
		m_edit_number = nGL::seedNumber;
		break;
	}
	UpdateData(false);
}

BOOL nInputDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_width  = nGL::window_width;
	m_height = nGL::window_height;

	m_min_x  = nGL::field_min_x;
	m_min_y  = nGL::field_min_y;
	m_max_x  = nGL::field_max_x;
	m_max_y  = nGL::field_max_y;
	m_center_x  = nGL::field_center_x;
	m_center_y  = nGL::field_center_y;
	m_haba  = nGL::field_haba;

	m_radius = nGL::radius;
	m_theta  = nGL::theta;
	m_phi    = nGL::phi;

	m_origin_x  = nGL::re_convert_x(nGL::origin_x);
	m_origin_y  = nGL::re_convert_y(nGL::origin_y);
	m_origin_z  = nGL::re_convert_z(nGL::origin_z);

	UpdateData(false);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void nInputDialog::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	
	CDialog::OnCancel();
}

void nInputDialog::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	UpdateData(true);

	nGL::radius = m_radius;
	nGL::theta  = m_theta;
	nGL::phi    = m_phi;

	nGL::origin_x = m_origin_x;
	nGL::origin_y = m_origin_y;
	nGL::origin_z = m_origin_z;

	nGL::convert_x(&nGL::origin_x);
	nGL::convert_y(&nGL::origin_y);
	nGL::convert_z(&nGL::origin_z);
	
	CDialog::OnOK();
}
