// kDaughterView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Ion.h"
#include "kDaughterView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// kDaughterView

IMPLEMENT_DYNCREATE(kDaughterView, CFormView)

kDaughterView::kDaughterView()
	: CFormView(kDaughterView::IDD)
{
	//{{AFX_DATA_INIT(kDaughterView)
	//}}AFX_DATA_INIT
	((CIonApp*)AfxGetApp())->setDaughterView(this);
}

kDaughterView::~kDaughterView()
{
	((CIonApp*)AfxGetApp())->closeWindowDaughter();
	((CIonApp*)AfxGetApp())->setDaughterView(NULL);
}

void kDaughterView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(kDaughterView)
	DDX_Control(pDX, IDC_EDIT_TURN, m_edit_turn);
	DDX_Control(pDX, IDC_EDIT_ENERGY, m_edit_energy);
	DDX_Control(pDX, IDC_EDIT_KEEP_ENERGY, m_e_keep_energy);
	DDX_Control(pDX, IDC_EDIT_TOTAL_ENERGY, m_e_total_energy);
	DDX_Control(pDX, IDC_EDIT_USED_ENERGY, m_e_used_energy);
	DDX_Control(pDX, IDC_EDIT_SEED_NUMBER, m_e_seed_number);
	DDX_Control(pDX, IDC_EDIT_GET_ENERGY, m_e_get_energy);
	DDX_Control(pDX, IDC_EDIT_GENE_NUMBER, m_e_gene_number);
	DDX_Control(pDX, IDC_EDIT_FIELD_CAPACITY, m_e_field_capacity);
	DDX_Control(pDX, IDC_EDIT_EXECUTE_NUMBER, m_e_execute_number);
	DDX_Control(pDX, IDC_EDIT_CURRENT_DEATH_NUMBER, m_e_current_death);
	DDX_Control(pDX, IDC_EDIT_CURRENT_BIRTH_NUMBER, m_e_current_birth);
	DDX_Control(pDX, IDC_EDIT_AVERAGE_TURN, m_e_average_turn);
	DDX_Control(pDX, IDC_EDIT_AVERAGE_SIZE, m_e_average_size);
	DDX_Control(pDX, IDC_EDIT_AVERAGE_EVALUATION, m_e_average_evaluation);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(kDaughterView, CFormView)
	//{{AFX_MSG_MAP(kDaughterView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// kDaughterView ff

#ifdef _DEBUG
void kDaughterView::AssertValid() const
{
	CFormView::AssertValid();
}

void kDaughterView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// kDaughterView bZ[W nh


void kDaughterView::dataDisplay()
{
	mMother* mother = ((CIonApp*)AfxGetApp())->getMother();
	if(!mother){
		return;
	}

	mDaughter* child = mother->getChild();
	mSeedList* seedList = child->getSeedList();
	mGeneList* geneList = child->getGeneList();
	mField* field = child->getField();
	mEnergy* energy = seedList->getEnergy();

	seedList->calculateEnergy();

	mInt seedNumber = seedList->getSeedVector()->size();
	
	dataSet(m_e_seed_number,seedNumber);
	dataSet(m_e_gene_number , geneList->getGeneNumber());
	dataSet(m_e_average_evaluation , seedList->getAverageEvaluationValue());
	dataSet(m_e_average_size , seedList->getAverageSize());
	dataSet(m_e_average_turn , seedList->getAverageTurnNumber());
	dataSet(m_e_current_birth , seedList->getCurrentBirthNumber());
	dataSet(m_e_current_death , seedList->getCurrentDeathNumber());
	dataSet(m_e_execute_number , child->getCurrentTime());
	dataSet(m_e_field_capacity , field->getCapacity());

	dataSet(m_e_total_energy , field->getTotalEnergy());
	dataSet(m_e_keep_energy , energy->getKeepEnergy()*seedNumber);
	dataSet(m_e_get_energy , energy->getTotalEnergy()*seedNumber);
	dataSet(m_e_used_energy , energy->getUsedEnergy()*seedNumber);

	dataSet(m_edit_turn , child->getTurnNumber());

	m_edit_energy.SetWindowText(energy->makeString());
}

void kDaughterView::dataSet(CEdit &edit, mInt value)
{
	CString newString;
	newString.Format("%d",value);
	edit.SetWindowText(newString);
}

void kDaughterView::dataSet(CEdit &edit, mDouble value)
{
	CString newString;
	newString.Format("%.10lf",value);
	edit.SetWindowText(newString);
}

void kDaughterView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	dataDisplay();	
}
