// kGeneView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Ion.h"
#include "kGeneView.h"
#include "kTarget.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// kGeneView

IMPLEMENT_DYNCREATE(kGeneView, CFormView)

kGeneView::kGeneView()
	: CFormView(kGeneView::IDD)
{
	//{{AFX_DATA_INIT(kGeneView)
	//}}AFX_DATA_INIT
	((CIonApp*)AfxGetApp())->setGeneView(this);
	targetVector = NULL;
	targetGene = NULL;
}

kGeneView::~kGeneView()
{
	((CIonApp*)AfxGetApp())->closeWindowGene();
	((CIonApp*)AfxGetApp())->setGeneView(NULL);
}

void kGeneView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(kGeneView)
	DDX_Control(pDX, IDC_BUTTON_SAVE_CODE, m_button_save_code);
	DDX_Control(pDX, IDC_BUTTON_TARGET, m_button_target);
	DDX_Control(pDX, IDC_EDIT_ENERGY, m_edit_energy);
	DDX_Control(pDX, IDC_EDIT_CALORIE, m_edit_calorie);
	DDX_Control(pDX, IDC_EDIT_CODE, m_edit_code);
	DDX_Control(pDX, IDC_EDIT_VOLUME, m_edit_volume);
	DDX_Control(pDX, IDC_EDIT_TURN, m_edit_turn);
	DDX_Control(pDX, IDC_EDIT_SEED_NUMBER, m_edit_seed_number);
	DDX_Control(pDX, IDC_EDIT_GENE_ID, m_edit_gene_id);
	DDX_Control(pDX, IDC_EDIT_EVALUATION_VALUE, m_edit_evaluation_value);
	DDX_Control(pDX, IDC_COMBO_SIZE, m_combo_size);
	DDX_Control(pDX, IDC_COMBO_SEEDS, m_combo_seeds);
	DDX_Control(pDX, IDC_COMBO_ID, m_combo_id);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(kGeneView, CFormView)
	//{{AFX_MSG_MAP(kGeneView)
	ON_CBN_SETFOCUS(IDC_COMBO_SIZE, OnSetfocusComboSize)
	ON_CBN_SELCHANGE(IDC_COMBO_SIZE, OnSelchangeComboSize)
	ON_CBN_SELCHANGE(IDC_COMBO_ID, OnSelchangeComboId)
	ON_BN_CLICKED(IDC_BUTTON_TARGET, OnButtonTarget)
	ON_CBN_SELCHANGE(IDC_COMBO_SEEDS, OnSelchangeComboSeeds)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_CODE, OnButtonSaveCode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// kGeneView ff

#ifdef _DEBUG
void kGeneView::AssertValid() const
{
	CFormView::AssertValid();
}

void kGeneView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// kGeneView bZ[W nh


void kGeneView::dataDisplay()
{
	targetVector = NULL;
}

void kGeneView::dataDiplayIn(mGene *targetGene)
{
	if(targetGene == NULL){
		AfxMessageBox("̃W[Xg܂");
		return;
	}
	vector<mSeed*>* seeds = targetGene->getSeeds();
	if(seeds == NULL || seeds->size()==0){
		AfxMessageBox("̃W[Xg܂");
		return;
	}

	int nn,i;
	nn = m_combo_seeds.GetCount();
	for(i = nn-1;i>=0;--i){
		m_combo_seeds.DeleteString(i);
	}

	const int length = seeds->size();
	setData(m_edit_gene_id,targetGene->getID()->toString());
	setData(m_edit_seed_number,length);

	mDouble evaluation = 0.0;
	mDouble turn = 0.0;
	mDouble volume = 0.0;
	mDouble calorie = 0.0;
	mEnergy energy;

	for(vector<mSeed*>::iterator itSeed = seeds->begin();
			itSeed != seeds->end();
			++itSeed){
		evaluation += (*itSeed)->getEvaluationValue();
		turn += (*itSeed)->getTurnNumber();
		volume +=(*itSeed)->getPartsList()->getVolume();
		calorie +=(*itSeed)->getPartsList()->getCalorie();
		energy.addOtherEnergy((*itSeed)->getCPU()->getEnergy());
		m_combo_seeds.InsertString(-1,(*itSeed)->getID()->toString());
	}

	const double dlength = (double)length;
	evaluation /= dlength;
	turn /= dlength;
	volume /= dlength;
	calorie /= dlength;
	energy.divideByNumber(length);

	setData(m_edit_evaluation_value,evaluation);
	setData(m_edit_turn,turn);
	setData(m_edit_volume,volume);
	setData(m_edit_calorie,calorie);

	setData(m_edit_code,targetGene->makeCodeString());
	//GlM[̕\s
	setData(m_edit_energy,energy.makeString());
	m_button_target.EnableWindow(true);
	m_button_save_code.EnableWindow(true);
}

void kGeneView::setData(CEdit &edit, const mInt value)
{
	CString newString;
	newString.Format("%d",value);
	edit.SetWindowText(newString);
}

void kGeneView::setData(CEdit &edit, const mDouble value)
{
	CString newString;
	newString.Format("%.10lf",value);
	edit.SetWindowText(newString);

}

void kGeneView::setData(CEdit &edit, const CString value)
{
	edit.SetWindowText(value);
}

void kGeneView::OnSetfocusComboSize() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	mGeneList* geneList = ((CIonApp*)AfxGetApp())
		->getChild()->getGeneList();
	vector<mInt> sizeVector = geneList->getSizesList();

	int nn,i;
	nn = m_combo_size.GetCount();
	for(i = nn-1;i>=0;--i){
		m_combo_size.DeleteString(i);
	}
	nn = m_combo_id.GetCount();
	for(i = nn-1;i>=0;--i){
		m_combo_id.DeleteString(i);
	}
	targetVector = NULL;

	CString newString;
	for(vector<mInt>::iterator itSize = sizeVector.begin();
			itSize != sizeVector.end();
			++itSize){
		newString.Format("%d",(*itSize));
		m_combo_size.InsertString(-1,newString);
	}

}

void kGeneView::OnSelchangeComboSize() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int nn,i;
	nn = m_combo_id.GetCount();
	for(i = nn-1;i>=0;--i){
		m_combo_id.DeleteString(i);
	}
	const int index = m_combo_size.GetCurSel();
	if(index == CB_ERR){
		return ;// IĂȂ
	}
	CString tmpString;
	m_combo_size.GetLBText(index,tmpString);
	mInt size;
	sscanf(tmpString.operator LPCTSTR(),"%d",&size);
	
	targetVector = ((CIonApp*)AfxGetApp())->getChild()
		->getGeneList()->getGeneVector(size);
	if(targetVector == NULL){
		AfxMessageBox("̃TCỸW[Xg܂");
		return;
	}
	vector<mGene*>* genes = targetVector->getGenes();
	if(genes){
		for(vector<mGene*>::iterator itGene = genes->begin();
				itGene != genes->end();
				++itGene){
			m_combo_id.InsertString(-1,(*itGene)->getID()->toString());
		}
	}

}

void kGeneView::OnSelchangeComboId() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	const int index = m_combo_id.GetCurSel();
	if(index == CB_ERR){
		return ;// IĂȂ
	}
	if(targetVector == NULL){
		AfxMessageBox("̃TCỸW[Xg܂");
		return;
	}
	vector<mGene*>* genes = targetVector->getGenes();
	if(genes == NULL){
		AfxMessageBox("̃TCỸW[Xg܂");
		return;
	}
	if(index <0 || index >=genes->size()){
		AfxMessageBox("ID̃W[Xg܂");
		return;
	}
	targetGene = *(genes->begin()+index);
	CString IDString;
	m_combo_id.GetWindowText(IDString);
	if(IDString.Compare(targetGene->getID()->toString())!=0){
		//ǂIDႤ悤
		AfxMessageBox("ID̃W[Xg܂");
		return;
	}
	dataDiplayIn(targetGene);
}

void kGeneView::deleteComboSelection()
{
	int nn,i;
	nn = m_combo_id.GetCount();
	for(i = nn-1;i>=0;--i){
		m_combo_id.DeleteString(i);
	}
	nn = m_combo_size.GetCount();
	for(i = nn-1;i>=0;--i){
		m_combo_size.DeleteString(i);
	}
	nn = m_combo_seeds.GetCount();
	for(i = nn-1;i>=0;--i){
		m_combo_seeds.DeleteString(i);
	}
	targetGene = NULL;
	m_button_target.EnableWindow(false);
	m_button_save_code.EnableWindow(false);
}

mSeed* kGeneView::makeDummySeed()
{
	/*V[h\ɂ
	mGene* gene,
	mPartsList* partsList,
	mID* ID,
	mPoint3D* centerPoint3D,
	mInt isBirth,
	mDouble initialEnergy
	̈KvŁA
	̒ŃfXgN^deletê
	IDcenterPoint3D̂QłB
	܂partsListłNULLw肷
	*/
	if(targetGene == NULL){
		return NULL;
	}
	mID* originalID = targetGene->getID();
	mID* newID = new mID(originalID->getSize(),
			originalID->getBornTime(),
			originalID->getIs1st());
	mField* field = ((CIonApp*)AfxGetApp())->getChild()->getField();
	mDouble center_x = field->calculate_center_x();
	mDouble center_y = field->calculate_center_y();
	mPoint3D* newCenterPoint3D = new mPoint3D(center_x,center_y,0.0);
	const mInt isBirth = 0;
	const mDouble initialEnergy = 0.0;

	mSeed* newSeed = new mSeed(targetGene,NULL,
		newID,newCenterPoint3D,isBirth,initialEnergy);
	return newSeed;
}

void kGeneView::OnButtonTarget() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(targetGene==NULL){
		AfxMessageBox("^[QbgłĂ܂");
		return;
	}
	mSeed* targetSeed = makeDummySeed();
		//̃CX^X͂̃\bhdelete邱
	kTarget target(targetSeed);
	target.DoModal();
	delete targetSeed;
}

void kGeneView::OnSelchangeComboSeeds() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	kSeedView* seedView = ((CIonApp*)AfxGetApp())->getSeedView();
	if(seedView == NULL){
		return;
	}
	if(targetVector == NULL || targetGene == NULL){
		return;
	}
	const int index = m_combo_seeds.GetCurSel();
	if(index == CB_ERR){
		return ;// IĂȂ
	}
	CString tmpString;
	m_combo_seeds.GetLBText(index,tmpString);
	mSeed* targetSeed = *(targetGene->getSeeds()->begin()+index);
	if(targetSeed == NULL){
		return;
	}
	//ł悤₭Ił
	if(tmpString.Compare(targetSeed->getID()->toString())!=0){
		return;
	}

	const int value = AfxMessageBox("̃V[hSeedViewɔf܂",MB_YESNO);
	if(value == IDYES){
		seedView->dataDisplayIn(targetSeed);
	}
}

void kGeneView::OnButtonSaveCode() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(targetGene == NULL){
		return;
	}
	CString IDString = targetGene->getID()->toString();
	CString tmpFileName = CString("ID")+IDString+".gene";
	
	CString saveString;
	m_edit_code.GetWindowText(saveString);
	saveString.Remove('\x0a'); //t@CɃZ[uƂ͂ύXĂ

	CFileDialog fileDialog(false,"gene",tmpFileName,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Gene Files (*.gene)|*.gene||",this);
	CIonApp* currentApp = (CIonApp*)AfxGetApp();
	fileDialog.m_ofn.lpstrInitialDir = currentApp->getPathName();

	if(fileDialog.DoModal()==IDOK){
		CString fileName = fileDialog.GetPathName();
		currentApp->waitFile();
		currentApp->fileLock();
		ofstream os(fileName);
		os << "/*----------------------*/" <<endl;
		os << "  this is gene file" << endl;
		os << "  " << IDString << endl;
		os << "/*----------------------*/" <<endl;
		os << saveString << endl;
		os.close();
		currentApp->fileUnlock();
	}
}
