// kSeedView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Ion.h"
#include "kSeedView.h"
#include "kTarget.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// kSeedView

IMPLEMENT_DYNCREATE(kSeedView, CFormView)

kSeedView::kSeedView()
	: CFormView(kSeedView::IDD)
{
	//{{AFX_DATA_INIT(kSeedView)
	//}}AFX_DATA_INIT
	((CIonApp*)AfxGetApp())->setSeedView(this);
	targetSeed = NULL;
}


kSeedView::~kSeedView()
{
	((CIonApp*)AfxGetApp())->closeWindowSeed();
	((CIonApp*)AfxGetApp())->setSeedView(NULL);
}

void kSeedView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(kSeedView)
	DDX_Control(pDX, IDC_BUTTON_TARGET, m_button_target);
	DDX_Control(pDX, IDC_EDIT_ENERGY, m_edit_energy);
	DDX_Control(pDX, IDC_EDIT_EVALUATION_VALUE, m_edit_evaluation_value);
	DDX_Control(pDX, IDC_RADIO_PERFECT, m_radio_perfect);
	DDX_Control(pDX, IDC_RADIO_IDENTITY, m_radio_identity);
	DDX_Control(pDX, IDC_RADIO_CUT, m_radio_cut);
	DDX_Control(pDX, IDC_EDIT_SEED_ID, m_edit_seed_id);
	DDX_Control(pDX, IDC_EDIT_BIRTH_NUMBER, m_edit_birth_number);
	DDX_Control(pDX, IDC_EDIT_VOLUME, m_edit_volume);
	DDX_Control(pDX, IDC_EDIT_TURN, m_edit_turn);
	DDX_Control(pDX, IDC_EDIT_IS_BIRTH, m_edit_is_birth);
	DDX_Control(pDX, IDC_EDIT_GENE_ID, m_edit_gene_id);
	DDX_Control(pDX, IDC_EDIT_DONE_WORK, m_edit_done_work);
	DDX_Control(pDX, IDC_EDIT_CENTER, m_edit_center);
	DDX_Control(pDX, IDC_EDIT_CALORIE, m_edit_carolie);
	DDX_Control(pDX, IDC_EDIT_ABUFFER, m_edit_abuffer);
	DDX_Control(pDX, IDC_COMB_SIZE, m_combo_size);
	DDX_Control(pDX, IDC_COMB_ID, m_combo_ID);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(kSeedView, CFormView)
	//{{AFX_MSG_MAP(kSeedView)
	ON_CBN_SETFOCUS(IDC_COMB_SIZE, OnSetfocusCombSize)
	ON_CBN_SELCHANGE(IDC_COMB_SIZE, OnSelchangeCombSize)
	ON_CBN_SELCHANGE(IDC_COMB_ID, OnSelchangeCombId)
	ON_BN_CLICKED(IDC_BUTTON_TARGET, OnButtonTarget)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// kSeedView ff

#ifdef _DEBUG
void kSeedView::AssertValid() const
{
	CFormView::AssertValid();
}

void kSeedView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// kSeedView bZ[W nh

void kSeedView::dataDisplayIn(mSeed *targetSeed)
{
	if(targetSeed == NULL){
		return;
	}
	this->targetSeed = targetSeed;
	mCPU* CPU = targetSeed->getCPU();
	mEnergy* energy = CPU->getEnergy();
	mPartsList* partsList = targetSeed->getPartsList();
	mGene* gene = targetSeed->getGene();

	setData(m_edit_abuffer,partsList->getABuffer());
	setData(m_edit_birth_number,CPU->getBreedNumber());
	setData(m_edit_carolie,partsList->getCalorie());
	setData(m_edit_center,targetSeed->getCenterPoint3D()->toString());
	setData(m_edit_done_work,CPU->getDoneWork());
	setData(m_edit_energy,energy->makeString());
	setData(m_edit_evaluation_value,targetSeed->getEvaluationValue());
	setData(m_edit_gene_id,gene->getID()->toString());
	setData(m_edit_is_birth,targetSeed->getIsBirth());
	setData(m_edit_seed_id,targetSeed->getID()->toString());
	setData(m_edit_turn,targetSeed->getTurnNumber());
	setData(m_edit_volume,partsList->getVolume());
	m_button_target.EnableWindow(true);
}

void kSeedView::setData(CEdit &edit, mInt value)
{
	CString newString;
	newString.Format("%d",value);
	edit.SetWindowText(newString);

}

void kSeedView::setData(CEdit &edit, mDouble value)
{
	CString newString;
	newString.Format("%lf",value);
	edit.SetWindowText(newString);

}

void kSeedView::setData(CEdit &edit, CString &value)
{
	edit.SetWindowText(value);
}

void kSeedView::OnSetfocusCombSize() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	deleteComboSelection();
	vector<mInt> sizesList = ((CIonApp*)AfxGetApp())
		->getChild()->getGeneList()->getSizesList();
	int length = sizesList.size();
	CString newString;
	vector<mInt>::iterator it = sizesList.begin();
	for(int i=0;i<length;++i,++it){
		newString.Format("%d",*it);
		m_combo_size.InsertString(-1,newString);
	}
}

void kSeedView::OnSelchangeCombSize() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int index = m_combo_size.GetCurSel();
	if(index == CB_ERR){
		return ;// IĂȂ
	}
	CString tmpString;
	m_combo_size.GetLBText(index,tmpString);
	mInt size;
	sscanf(tmpString.operator LPCTSTR(),"%d",&size);

	vector<mSeed*> newSeedList = 
		((CIonApp*)AfxGetApp())->getChild()
		->getGeneList()->getSeedsList(size);
	if(newSeedList.size()==0){
		AfxMessageBox("̃TCỸV[hXg܂");
		return;
	}
	seedSizeList.clear();
	seedSizeList = newSeedList;

	sort(seedSizeList.begin(),seedSizeList.end(),mSeed::IDSort);

	int nn,i;
	nn = m_combo_ID.GetCount();
	for(i=nn-1;i>=0;--i){
		m_combo_ID.DeleteString(i);
	}

	const int length = seedSizeList.size();
	CString newString;
	vector<mSeed*>::iterator itSeed = seedSizeList.begin();
	for(i=0;i<length;++i ,++itSeed){
		newString.Format("%s",(*itSeed)->getID()->toString().operator LPCTSTR());
		m_combo_ID.InsertString(-1,newString);
	}
}

void kSeedView::OnSelchangeCombId() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int index = m_combo_ID.GetCurSel();
	if(index == CB_ERR){
		return ;// IĂȂ
	}
	CString tmpString;
	m_combo_ID.GetLBText(index,tmpString);

	if(index < 0 || index >= seedSizeList.size()){
		AfxMessageBox("IDV[hXg܂");
		return;
	}
	targetSeed = *(seedSizeList.begin()+index);
	if(targetSeed == NULL || tmpString.Compare(targetSeed->getID()->toString())!=0){
		AfxMessageBox("IDV[hXg܂");
		return;
	}
	dataDisplayIn(targetSeed);
}

void kSeedView::dataDisplay(mSeed *targetSeed)
{
	if(targetSeed == NULL){
		//^[QbgȂ珑ƂłȂ
		return;
	}
	if(m_radio_cut.GetCheck()){
		return; //cutĂ邩牽Ȃ
	}
	if(m_radio_perfect.GetCheck()){
		dataDisplayIn(targetSeed); //SǐՂ̏ꍇׂ͂ď
	}
	if(m_radio_identity.GetCheck()){
		CString seedString;
		m_edit_seed_id.GetWindowText(seedString);
		if(seedString.Compare(targetSeed->getID()->toString())==0){
			// ID  ܂ɂȂĂ邩\
			dataDisplayIn(targetSeed);
		}
	}
}

void kSeedView::deleteComboSelection()
{
	seedSizeList.clear();
	int nn,i;
	nn = m_combo_ID.GetCount();
	for(i=nn-1;i>=0;--i){
		m_combo_ID.DeleteString(i);
	}
	nn = m_combo_size.GetCount();
	for(i=nn-1;i>=0;--i){
		m_combo_size.DeleteString(i);
	}
	targetSeed = NULL;
	m_button_target.EnableWindow(false);
}

void kSeedView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	m_radio_cut.SetCheck(1);
		//Ԃ̓JbgɂĂ
	if(targetSeed){
		m_button_target.EnableWindow(true);
	}
}

void kSeedView::OnButtonTarget() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(targetSeed == NULL){
		return;
	}
	kTarget target(targetSeed);
	target.DoModal();
}
