// kSizeView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Ion.h"
#include "kSizeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// kSizeView

IMPLEMENT_DYNCREATE(kSizeView, CFormView)

kSizeView::kSizeView()
	: CFormView(kSizeView::IDD)
{
	//{{AFX_DATA_INIT(kSizeView)
	//}}AFX_DATA_INIT
	((CIonApp*)AfxGetApp())->setSizeView(this);
}

kSizeView::~kSizeView()
{
	((CIonApp*)AfxGetApp())->closeWindowSize();
	((CIonApp*)AfxGetApp())->setSizeView(NULL);
}

void kSizeView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(kSizeView)
	DDX_Control(pDX, IDC_EDIT_SIZE_FREQ, m_edit_size_freq);
	DDX_Control(pDX, IDC_EDIT_GENE_FREQ, m_edit_gene_freq);
	DDX_Control(pDX, IDC_EDIT_FREQ_SIZE, m_edit_freq_size);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(kSizeView, CFormView)
	//{{AFX_MSG_MAP(kSizeView)
	ON_BN_CLICKED(IDC_BUTTON_SIZE_FREQ, OnButtonSizeFreq)
	ON_BN_CLICKED(IDC_BUTTON_FREQ_SIZE, OnButtonFreqSize)
	ON_BN_CLICKED(IDC_BUTTON_GENE_FREQ, OnButtonGeneFreq)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// kSizeView ff

#ifdef _DEBUG
void kSizeView::AssertValid() const
{
	CFormView::AssertValid();
}

void kSizeView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// kSizeView bZ[W nh

void kSizeView::dataDisplay()
{
	//ł镔폜Ă

	mGeneList* geneList = ((CIonApp*)AfxGetApp())
			->getChild()->getGeneList();
	vector<mGeneList::mSizeFreq*> sizeFreqList 
		= geneList->getSizeFreqList();
	vector<mGeneList::mGeneFreq*> geneFreqList 
		= geneList->getGeneFreqList();

	CString newString;

	//sizȅق\[g
	sort(sizeFreqList.begin(),sizeFreqList.end(),mGeneList::smallerThan);

	CString sizeFreqString;
	for(vector<mGeneList::mSizeFreq*>::iterator itSizeFreq = sizeFreqList.begin();
			itSizeFreq != sizeFreqList.end();
			++itSizeFreq){
		if(*itSizeFreq){
			newString.Format("%d    %d\x0d\x0a",(*itSizeFreq)->size,(*itSizeFreq)->freq);
			sizeFreqString += newString;
		}
	} // end of for
	m_edit_size_freq.SetWindowText(sizeFreqString);

	//freq̑ق\[g
	sort(sizeFreqList.begin(),sizeFreqList.end(),mGeneList::moreThanSize);
	CString freqSizeString;
	for(itSizeFreq = sizeFreqList.begin();
			itSizeFreq != sizeFreqList.end();
			++itSizeFreq){
		if(*itSizeFreq){
			newString.Format("%d    %d\x0d\x0a",(*itSizeFreq)->size,(*itSizeFreq)->freq);
			freqSizeString += newString;
		}
	} // end of for
	m_edit_freq_size.SetWindowText(freqSizeString);

	//genȇق\[g
	sort(geneFreqList.begin(),geneFreqList.end(),mGeneList::moreThanGene);
	CString geneFreqString;
	for(vector<mGeneList::mGeneFreq*>::iterator itGeneFreq = geneFreqList.begin();
			itGeneFreq != geneFreqList.end();
			++itGeneFreq){
		if(*itGeneFreq){
			newString.Format("%s    %d",
				(*itGeneFreq)->IDString.operator LPCTSTR(),
				(*itGeneFreq)->freq);
			geneFreqString += newString + "\x0d\x0a";
		}
	} // end of for
	m_edit_gene_freq.SetWindowText(geneFreqString);

	for(itSizeFreq = sizeFreqList.begin();
			itSizeFreq != sizeFreqList.end();
			++itSizeFreq){
		if(*itSizeFreq){
			delete *itSizeFreq;
			*itSizeFreq = NULL;
			//deleteĂ
		}
	} // end of for

	for(itGeneFreq = geneFreqList.begin();
			itGeneFreq != geneFreqList.end();
			++itGeneFreq){
		if(*itGeneFreq){
			delete *itGeneFreq;
			*itGeneFreq = NULL;
			//deleteĂ
		}
	} // end of for

}

void kSizeView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	dataDisplay();
}

void kSizeView::fileSave(const CString& target,const CEdit &edit)
{
	CString cstring;
	edit.GetWindowText(cstring);
	CIonApp* currentApp = (CIonApp*)AfxGetApp();
	CFileDialog fileDialog(false,"frq",target,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ,
		"Ion Freq Data Files (*.frq)|*.frq||",currentApp->m_pMainWnd);
	fileDialog.m_ofn.lpstrInitialDir = currentApp->getPathName();
	if(fileDialog.DoModal()==IDOK){
		CString fileName = fileDialog.GetPathName();
		currentApp->waitFile();
		currentApp->fileLock();
		ofstream os(fileName);
		os << cstring << endl;
		os.close();
		currentApp->fileUnlock();
	}
}

void kSizeView::OnButtonSizeFreq() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	fileSave("size_frq.frq",m_edit_size_freq);
}

void kSizeView::OnButtonFreqSize() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	fileSave("frq_size.frq",m_edit_freq_size);	
}

void kSizeView::OnButtonGeneFreq() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	fileSave("gene_frq.frq",m_edit_gene_freq);
}
