// mCPU.cpp: mCPU NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mCPU.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mCPU::mCPU()
{
	//{IɎgpȂ
}


const mInt mCPU::OperatorNumber=32; //߂̎ނ̐

const mInt mCPU::RegistersNumber=10; //WX^̐

const CString mCPU::OperatorName[]={ //߂̖O
		"nop0", //"nop_0             ",
		"nop1", //"nop_1             ",
		"gsep", //"gene_separate     ",
		"ifcz", //"if_counter_zero   ",
		
		"jmpf", //"jump_forward      ",
		"jmpb", //"jump_back         ",
		"call", //"call              ",
		"ret " , //"ret               ",
		
		"push",	//"push              ",
		"pop ",	//"pop               ",
		"shl ",	//"shift_left        ",
		"shr ",	//"shift_right       ",
		
		"inc ",	//"increment         ",
		"dec ",	//"decrement         ",
		"zero",	//"zero              ",
		"cute",	//"cut_edge          ",
		
		"s_fn",	//"set_flower_number ",
		"s_ln",	//"set_leaf_number   ",
		"s_fe",	//"set_flower_energy ",
		"s_le",	//"set_leaf_energy   ",
		
		"s_nn",	//"set_node_number   ",
		"s_en",	//"set_edge_number   ",
		"s_ph",	//"set_phy           ",
		"s_th",	//"set_theta         ",
		
		"s_r ",	//"set_r             ",
		"s_ct",	//"set_counter       ",
		"makf",	//"make_flower       ",
		"makl",	//"make_leaf         ",
		
		"makn",	//"make_node         ",
		"grwf",	//"grow_flower       ",
		"grwl",	//"grow_leaf         ",
		"bred"	//"breed_flower      "
};

const CString mCPU::LongOperatorName[]={ //߂̖O
		"nop_0             ",
		"nop_1             ",
		"gene_separate     ",
		"if_counter_zero   ",
		
		"jump_forward      ",
		"jump_back         ",
		"call              ",
		"ret               ",
		
		"push              ",
		"pop               ",
		"shift_left        ",
		"shift_right       ",
		
		"increment         ",
		"decrement         ",
		"zero              ",
		"cut_edge          ",
		
		"set_flower_number ",
		"set_leaf_number   ",
		"set_flower_energy ",
		"set_leaf_energy   ",
		
		"set_node_number   ",
		"set_edge_number   ",
		"set_phy           ",
		"set_theta         ",
		
		"set_r             ",
		"set_counter       ",
		"make_flower       ",
		"make_leaf         ",
		
		"make_node         ",
		"grow_flower       ",
		"grow_leaf         ",
		"breed_flower      "
};

const CString mCPU::ShortOperatorName[]={ //߂̖O
		"nop0", //"nop_0             ",
		"nop1", //"nop_1             ",
		"gsep", //"gene_separate     ",
		"ifcz", //"if_counter_zero   ",
		
		"jmpf", //"jump_forward      ",
		"jmpb", //"jump_back         ",
		"call", //"call              ",
		"ret" , //"ret               ",
		
		"push",	//"push              ",
		"pop",	//"pop               ",
		"shl",	//"shift_left        ",
		"shr",	//"shift_right       ",
		
		"inc",	//"increment         ",
		"dec",	//"decrement         ",
		"zero",	//"zero              ",
		"cute",	//"cut_edge          ",
		
		"s_fn",	//"set_flower_number ",
		"s_ln",	//"set_leaf_number   ",
		"s_fe",	//"set_flower_energy ",
		"s_le",	//"set_leaf_energy   ",
		
		"s_nn",	//"set_node_number   ",
		"s_en",	//"set_edge_number   ",
		"s_ph",	//"set_phy           ",
		"s_th",	//"set_theta         ",
		
		"s_r",	//"set_r             ",
		"s_ct",	//"set_counter       ",
		"makf",	//"make_flower       ",
		"makl",	//"make_leaf         ",
		
		"makn",	//"make_node         ",
		"grwf",	//"grow_flower       ",
		"grwl",	//"grow_leaf         ",
		"bred"	//"breed_flower      "
};

const CString mCPU::RegisterName[]={ //WX^̖O
			"r  ",
			"th ",
			"ph ",
			"f_n",
			"l_n",
			"n_n",
			"e_n",
			"f_e",
			"l_e",
			"co"
};

mCPU::mCPU(mSeed *seed)
{
	this->seed=seed;
	partsList=seed->getPartsList(); //p[cXg̓o^
	gene=seed->getGene(); //W[̓o^
	if(gene){
		code = gene->getCode() ; //R[h̓o^
		size = gene->getSize() ; //TCY̓o^
	}else{
		code = NULL;
		size = 0;
	}
	// ܂ł͓o^Ă邾Ȃ̂
	// ̃NXdeleteȂ

	energy = NULL;
	ipStack = NULL;
	registerStack = NULL;
	registers = NULL;
	//  NULL  ی̂

	energy = new mEnergy;
	ipStack = new stack<mInt>;
	registerStack = new stack<mDouble>;
	registers = new mDouble[RegistersNumber];
	// ܂ł̂͂̃NXdelete邱

	//WX^ނ̏
	for(mInt i=0;i<RegistersNumber;++i){
		registers[i]=0.0;
	}
	registerIndex = r ; //Ƃ肠WX^ r ɂĂ
	ip=0; //ip  0 ŏAR[h̍ŏs
	breedNumber = 0;//񂾂̐͏l͂O
	doneWork="";

	//o֐̓o^s( execute \bh̎s΂₭s)
	mapOperator[nop_0]              = f_nop_0;
	mapOperator[nop_1]              = f_nop_1;
	mapOperator[gene_separate]      = f_gene_separate;
	mapOperator[if_counter_zero]    = f_if_counter_zero;

	mapOperator[jump_forward]       = f_jump_forward;
	mapOperator[jump_back]          = f_jump_back;
	mapOperator[call]               = f_call;
	mapOperator[ret]                = f_ret;

	mapOperator[push]               = f_push;
	mapOperator[pop]                = f_pop;
	mapOperator[shift_left]         = f_shift_left;
	mapOperator[shift_right]        = f_shift_right;

	mapOperator[increment]          = f_increment;
	mapOperator[decrement]          = f_decrement;
	mapOperator[zero]               = f_zero;
	mapOperator[cut_edge]           = f_cut_edge;

	mapOperator[set_flower_number]  = f_set_flower_number;
	mapOperator[set_leaf_number]    = f_set_leaf_number;
	mapOperator[set_flower_energy]  = f_set_flower_energy;
	mapOperator[set_leaf_energy]    = f_set_leaf_energy;

	mapOperator[set_node_number]    = f_set_node_number;
	mapOperator[set_edge_number]    = f_set_edge_number;
	mapOperator[set_phy]            = f_set_phy;
	mapOperator[set_theta]          = f_set_theta;

	mapOperator[set_r]              = f_set_r;
	mapOperator[set_counter]        = f_set_counter;
	mapOperator[make_flower]        = f_make_flower;
	mapOperator[make_leaf]          = f_make_leaf;

	mapOperator[make_node]          = f_make_node;
	mapOperator[grow_flower]        = f_grow_flower;
	mapOperator[grow_leaf]          = f_grow_leaf;
	mapOperator[breed_flower]       = f_breed_flower;

}

mCPU::~mCPU()
{
	//{Iɂ̓RXgN^ new 
	//̂ delete 
	if(energy){
		delete energy;
		energy=NULL;
	}
	if(ipStack){
		delete ipStack;
		ipStack=NULL;
	}
	if(registerStack){
		delete registerStack;
		registerStack=NULL;
	}
	if(registers){
		delete[] registers;
		registers=NULL;
	}
}

CString mCPU::toString()
{
	return CString("CPU of ")+seed->toString() ;
}

void mCPU::selfLoad(istream &is)
{
	CString comment;
	is>>comment;
	//RXgN^̒iK new Ă͂
	energy->selfLoad(is);
	if(seed){
		size = seed->getID()->getSize();
		gene = seed->getGene();
		code = gene->getCode();
	}
	is >> doneWork;
	if(doneWork.Compare("empty")==0){
		doneWork = "";
	}
	is >> ip >> registerIndex >> breedNumber;
	for(mInt i=0;i<mCPU::RegistersNumber;++i){
		is >> registers[i];
	}
	//Ƃ̓X^bN[h
	mInt stackSize;
	is >> stackSize;
	for(i=0;i<stackSize;++i){
		//X^bNɕA
		mInt intValue;
		is>>intValue;
		ipStack->push(intValue);
	}

	is >> stackSize;
	for(i=0;i<stackSize;++i){
		//X^bNɕA
		mDouble doubleValue;
		is>>doubleValue;
		registerStack->push(doubleValue);
	}

	is>>comment;
}

void mCPU::selfSave(ostream &os)
{
	os << "/*mCPU start*/"<<endl;
	//ꂼ̗vfŃZ[uȂǂĂ炤
	energy->selfSave(os);
	if(doneWork.GetLength()==0){
		os << "empty"<<endl;
	}else{
		os << doneWork << endl;
	}
	os << ip << ' ' << registerIndex << ' '
		<< breedNumber<<endl;
	for(mInt i=0;i<RegistersNumber;++i){
		os << registers[i] <<' ';
	}
	os<<endl;
	//Ƃ̓X^bNZ[u
	os<<ipStack->size()<<endl;
	//xXgɕϊ
	list<mInt> listInt;
	while(ipStack->size()!=0){
		listInt.push_front(ipStack->top());
		ipStack->pop();
	}
	//Xǧ`Ńt@Cɕۑ
	list<mInt>::iterator iteratorInt;
	for(iteratorInt=listInt.begin();
			iteratorInt!=listInt.end();++iteratorInt){
		os<<*iteratorInt<<' ';
		//X^bNɕA
		ipStack->push(*iteratorInt);
	}
	os<<endl;
	
	os<<registerStack->size()<<endl;
	//xXgɕϊ
	list<mDouble> listDouble;
	while(registerStack->size()!=0){
		listDouble.push_front(registerStack->top());
		registerStack->pop();
	}
	//Xǧ`Ńt@Cɕۑ
	list<mDouble>::iterator iteratorDouble;
	for(iteratorDouble=listDouble.begin();
			iteratorDouble!=listDouble.end();++iteratorDouble){
		os<<*iteratorDouble<<' ';
		//X^bNɕA
		registerStack->push(*iteratorDouble);
	}
	os<<endl;
	os<<"/*mCPU end*/" <<endl;
}

void mCPU::execute()
{
	if(ip<0||ip>=size){
		// ip R[h͈̔͂яoĂ܂Ă
		f_error();
		ip = 0 ; //0ɖ߂Ă܂
		return;
	}
	if(code){
		mInt executeNumber=code[ip];
		//sׂ߂ŎoĂĂ
		if(executeNumber<0||executeNumber>=OperatorNumber){
			//߂݂ĂȂ
			f_error();
		}else{
			doneWork.Format("ip %d::",ip);
			doneWork += OperatorName[executeNumber]+' ';
			//s̓o^
			(this->*(mapOperator[executeNumber]))();
			//͂܂sǂȂ
		}
	}
	++ip; //̖߂ɐi
}

void mCPU::f_nop_0()
{
	//nop_0͓ɎdȂ
	//Ƃ̓GlM[
	energyProcess(nop_0,mParameter::mCPU_energy_nop_0);
}

void mCPU::f_nop_1()
{
	//nop_1͓ɎdȂ
	//Ƃ̓GlM[
	energyProcess(nop_1,mParameter::mCPU_energy_nop_1);

}

void mCPU::f_gene_separate()
{
	//gene_separate͓ɎdȂ
	//̖߂͐VgeneƂɎg
	//Ƃ̓GlM[
	energyProcess(gene_separate,mParameter::mCPU_energy_gene_separate);

}

void mCPU::f_if_counter_zero()
{
	//l덷lė]TȂ莝Ă
	if(registers[counter]>-0.5 && registers[counter]<0.5){
		//̏ꍇ͎̖߂s
		doneWork+="with next";
	}else{
		//̏ꍇ͎̖߂sȂ
		doneWork+="step next";
		++ip;
	}

	//ŌɃGlM[
	energyProcess(if_counter_zero,mParameter::mCPU_energy_if_counter_zero);
}

void mCPU::f_jump_forward()
{
	//Ȏev[gɔ
	mInt nextIP=searchForward();
	if(nextIP==-2){
		//WvɎs
		doneWork +="miss jump";
	}else{
		//Wvɐ
		doneWork +="sucess jump";
		ip=nextIP; //ł܂
	}
	//Ƃ̓GlM[
	energyProcess(jump_forward,mParameter::mCPU_energy_jump_forward);

}

void mCPU::f_jump_back()
{
	//̑ev[gɔ
	mInt nextIP=searchBack();
	if(nextIP==-2){
		//WvɎs
		doneWork +="miss jump";
	}else{
		//Wvɐ
		doneWork +="sucess jump";
		ip=nextIP;
	}
	//Ƃ̓GlM[
	energyProcess(jump_back,mParameter::mCPU_energy_jump_back);

}

void mCPU::f_call()
{
	//Ȏev[gɔ
	mInt nextIP=searchForward();
	//OɔׂȂƂ͌ɔ
	if(nextIP==-2){
		nextIP=searchBack();
	}
	if(nextIP==-2){
		//WvɎs
		doneWork +="miss jump";
	}else{
		//Wvɐ
		doneWork +="sucess jump";
		//X^bNɂ݂ipł
		ipStack->push(ip);
		ip=nextIP;
	}
	//Ƃ̓GlM[
	energyProcess(call,mParameter::mCPU_energy_call);

}

void mCPU::f_ret()
{
	if(ipStack->size()!=0){
		//return 邱Ƃł
		ip=ipStack->top();
		ipStack->pop();
		CString addString;
		addString.Format("with next %d",ip);
		doneWork+=addString;
	}else{
		//return 邱ƂłȂ
		doneWork+="cannot return";
	}
	//Ƃ̓GlM[
	energyProcess(ret,mParameter::mCPU_energy_ret);

}

void mCPU::f_push()
{
	//WX^̓eX^bNɂ
	registerStack->push(registers[registerIndex]);
	doneWork+=CString("with ")+RegisterName[registerIndex];
	//Ƃ̓GlM[
	energyProcess(push,mParameter::mCPU_energy_push);

}

void mCPU::f_pop()
{
	if(registerStack->size()!=0){
		//WX^̓eɃX^bN玝Ă
		registers[registerIndex] = registerStack->top();
		registerStack->pop();
		doneWork+=CString("with ")+RegisterName[registerIndex];
	}else{
		//X^bN
		doneWork+="empty stack";
	}

	//Ƃ̓GlM[
	energyProcess(pop,mParameter::mCPU_energy_pop);

}

void mCPU::f_shift_left()
{
	//WX^̓e2{
	registers[registerIndex] *= 2.0;
	doneWork+=CString("with ")+RegisterName[registerIndex];
	//Ƃ̓GlM[
	energyProcess(shift_left,mParameter::mCPU_energy_shift_left);

}

void mCPU::f_shift_right()
{
	//WX^̓e𔼕
	registers[registerIndex] /= 2.0;
	doneWork+=CString("with ")+RegisterName[registerIndex];
	//Ƃ̓GlM[
	energyProcess(shift_left,mParameter::mCPU_energy_shift_right);

}

void mCPU::f_increment()
{
	//WX^̓e 1 ₷
	registers[registerIndex] += 1.0;
	doneWork+=CString("with ")+RegisterName[registerIndex];
	//Ƃ̓GlM[
	energyProcess(increment,mParameter::mCPU_energy_increment);

}

void mCPU::f_decrement()
{
	//WX^̓e 1 炷
	registers[registerIndex] -= 1.0;
	if(registerIndex != r &&
			registerIndex != theta &&
			registerIndex != phy &&
			registerIndex != counter &&
			registers[registerIndex] < 0.0){
		registers[registerIndex] = 0.0;
		doneWork+=CString(" and seto to 0 with ")+RegisterName[registerIndex];
	}else{
		doneWork+=CString("with ")+RegisterName[registerIndex];
	}
	//Ƃ̓GlM[
	energyProcess(decrement,mParameter::mCPU_energy_decrement);

}

void mCPU::f_zero()
{
	//WX^̓e 0 ɂ
	registers[registerIndex] =0.0 ;
	doneWork+=CString("with ")+RegisterName[registerIndex];
	//Ƃ̓GlM[
	energyProcess(zero,mParameter::mCPU_energy_zero);

}

void mCPU::f_cut_edge()
{
	//}
	
	if(registers[edge_number] < 0.0){
		registers[edge_number] = 0.0;
	}

	if(partsList->cut_edge((mInt)registers[edge_number])){
		//}ɐ
		doneWork+="sucess";
	}else{
		//}Ɏs
		doneWork+="failure";
	}

	//Ƃ̓GlM[
	energyProcess(cut_edge,mParameter::mCPU_energy_cut_edge);

}

void mCPU::f_set_flower_number()
{
	//WX^̃Zbg
	registerIndex=flower_number;
	//Ƃ̓GlM[
	energyProcess(set_flower_number,mParameter::mCPU_energy_set_flower_number);

}

void mCPU::f_set_leaf_number()
{
	//WX^̃Zbg
	registerIndex=leaf_number;
	//Ƃ̓GlM[
	energyProcess(set_leaf_number,mParameter::mCPU_energy_set_leaf_number);

}

void mCPU::f_set_flower_energy()
{
	//WX^̃Zbg
	registerIndex=flower_energy;
	//Ƃ̓GlM[
	energyProcess(set_flower_energy,mParameter::mCPU_energy_set_flower_energy);

}

void mCPU::f_set_leaf_energy()
{
	//WX^̃Zbg
	registerIndex=leaf_energy;
	//Ƃ̓GlM[
	energyProcess(set_leaf_energy,mParameter::mCPU_energy_set_leaf_energy);

}

void mCPU::f_set_node_number()
{
	//WX^̃Zbg
	registerIndex=node_number;
	//Ƃ̓GlM[
	energyProcess(set_node_number,mParameter::mCPU_energy_set_node_number);

}


void mCPU::f_set_edge_number()
{
	//WX^̃Zbg
	registerIndex=edge_number;
	//Ƃ̓GlM[
	energyProcess(set_edge_number,mParameter::mCPU_energy_set_edge_number);

}

void mCPU::f_set_theta()
{
	//WX^̃Zbg
	registerIndex=theta;
	//Ƃ̓GlM[
	energyProcess(set_theta,mParameter::mCPU_energy_set_theta);

}

void mCPU::f_set_phy()
{
	//WX^̃Zbg
	registerIndex=phy;
	//Ƃ̓GlM[
	energyProcess(set_phy,mParameter::mCPU_energy_set_phy);

}

void mCPU::f_set_r()
{
	//WX^̃Zbg
	registerIndex=r;
	//Ƃ̓GlM[
	energyProcess(set_r,mParameter::mCPU_energy_set_r);

}

void mCPU::f_set_counter()
{
	//WX^̃Zbg
	registerIndex=counter;
	//Ƃ̓GlM[
	energyProcess(set_counter,mParameter::mCPU_energy_set_counter);

}

void mCPU::f_make_flower()
{
	//ŏ0̑傫̉Ԃ
	//phy,thetaWX^̒gۂ̒lɕϊ
	mDouble adjustTheta,adjustPhy;
	adjustThetaPhy(&adjustTheta,&adjustPhy);

	mDouble usedEnergy = mParameter::mCPU_energy_make_flower;
			//̏łǂꂾ̃GlM[g
	if(partsList->make_flower((mInt) registers[node_number],
			0.0/*register[flower_energy]*/,registers[r],
			adjustTheta,adjustPhy)){
		//Ԃ̂ɐ
		doneWork+="sucess";
		//usedEnergy+=registers[flower_energy];
		//ԂGlM[
		//ŏ͑傫0̉Ԃ
		usedEnergy += mEdge::calculateCalorie(registers[r]);
		//}̕Ă
	}else{
		//Ԃ̂Ɏs
		doneWork+="failure";
	}

	//Ƃ̓GlM[
	energyProcess(make_flower,usedEnergy);

}

void mCPU::f_make_leaf()
{
	//phy,thetaWX^̒gۂ̒lɕϊ
	mDouble adjustTheta,adjustPhy;
	adjustThetaPhy(&adjustTheta,&adjustPhy);

	mDouble usedEnergy = mParameter::mCPU_energy_make_leaf;
			//̏łǂꂾ̃GlM[g
	if(partsList->make_leaf((mInt) registers[node_number],
			registers[leaf_energy],registers[r],
			adjustTheta,adjustPhy)){
		//t̂ɐ
		doneWork+="sucess";
		usedEnergy+=registers[leaf_energy];
		//tGlM[
		usedEnergy += mEdge::calculateCalorie(registers[r]);
		//}̕Ă
	}else{
		//t̂Ɏs
		doneWork+="failure";
	}

	//Ƃ̓GlM[
	energyProcess(make_leaf,usedEnergy);

}

void mCPU::f_make_node()
{
	//phy,thetaWX^̒gۂ̒lɕϊ
	mDouble adjustTheta,adjustPhy;
	adjustThetaPhy(&adjustTheta,&adjustPhy);

	mDouble usedEnergy = mParameter::mCPU_energy_make_node;
	if(partsList->make_node((mInt) registers[node_number],
			registers[r],adjustTheta,adjustPhy)){
		//m[ĥɐ
		doneWork+="sucess";
		usedEnergy += mEdge::calculateCalorie(registers[r]);
		//}̕Ă
	}else{
		//m[ĥɎs
		doneWork+="failure";
	}

	//Ƃ̓GlM[
	energyProcess(make_node,usedEnergy);

}

void mCPU::f_grow_flower()
{
	//Ԃ傫
	mDouble usedEnergy = mParameter::mCPU_energy_grow_flower;
			//̏łǂꂾ̃GlM[g
	if(partsList->grow_flower((mInt) registers[flower_number],
			registers[flower_energy])){
		//Ԃ傫̂ɐ
		doneWork+="sucess";
		usedEnergy+=registers[flower_energy];
		//Ԃ傫GlM[
	}else{
		//Ԃ傫̂Ɏs
		doneWork+="failure";
	}

	//Ƃ̓GlM[
	energyProcess(grow_flower,usedEnergy);

}

void mCPU::f_grow_leaf()
{
	//t傫
	mDouble usedEnergy = mParameter::mCPU_energy_grow_leaf;
			//̏łǂꂾ̃GlM[g
	if(partsList->grow_leaf((mInt) registers[leaf_number],
			registers[leaf_energy])){
		//t傫̂ɐ
		doneWork+="sucess";
		usedEnergy+=registers[leaf_energy];
		//t傫GlM[
	}else{
		//t傫̂Ɏs
		doneWork+="failure";
	}

	//Ƃ̓GlM[
	energyProcess(grow_leaf,usedEnergy);

}

void mCPU::f_breed_flower()
{
	// breed  VV[h쐬
	mDouble usedEnergy = mParameter::mCPU_energy_breed_flower;
	mPoint3D* newPoint3D = NULL;
		//̃V[ḧʒu
	try{
		//܂^[QbgƂȂԂ肷B
		mFlower* targetFlower = partsList->getFlower((mInt)registers[flower_number]);
		if(targetFlower==NULL){
			doneWork+="cannot find target flower";
			if(newPoint3D){
				delete newPoint3D;
				newPoint3D=NULL;
			}
			energyProcess(breed_flower,usedEnergy);
			return;
		}
		mPoint3D* flowerCenterPoint3D=targetFlower->getCenterPoint3D();
		mDouble flowerCalorie=targetFlower->getCalorie();
		partsList->zero_flower((mInt)registers[flower_number]);
		//Ԃ̑傫𒲐
		mSeedList* seedList = seed->getSeedList();
		mGeneList* geneList = gene->getGeneList();
			//̃CX^X͂̃\bhdeleteȂ

		if(seedList == NULL){
			//V[hXg݂ĂȂ
			doneWork+="no seedList";
			++breedNumber; // kTarget̕\Ȃǂ𒲐邽
			if(newPoint3D){
				delete newPoint3D;
				newPoint3D=NULL;
			}
			energyProcess(breed_flower,usedEnergy);
			return;
		}

		newPoint3D=nextPoint3D(targetFlower->getCenterPoint3D());
			//ŐVꏊ܂
		if(mField::isInner(newPoint3D)==false){
			//tB[h̊OɏoĂ܂
			doneWork+="cannot make inner point";
			if(newPoint3D){
				delete newPoint3D;
				newPoint3D=NULL;
			}
			energyProcess(breed_flower,usedEnergy);
			return;
		}

		mDouble per; //motherfatherdaughterւ̊^
		mGene* fatherGene; //fathergene
			//̃CX^X͂̃\bhdeleteȂ
		fatherGene = seedList->selectFather(seed,flowerCenterPoint3D,&per);

		mGene* daughterGene = mGene::makeGene(gene,fatherGene,per);
		mID* daughterID = NULL;
		mGene* newGene = NULL;
		if(geneList->decideID(daughterGene,&daughterID,&newGene)){
			//Vgeneł͂Ȃ
			//̂ƂdaughterIDnewGeneɂ̓eĂ
			delete daughterGene;
			daughterGene=newGene;
		}else{
			//Vgeneł
			daughterID = geneList->makeNewID(daughterGene->getSize());
			//VID
			daughterGene->setID(daughterID);
			//VIDgeneɓo^
			geneList->addNewGene(daughterGene);
			//VgeneȂ̂ŃXgɓo^
		}
		mID* daughterSeedID= geneList->makeNewID(daughterGene->getSize());
		mSeed* daughterSeed = new mSeed(
			daughterGene,seedList,daughterSeedID,
			newPoint3D,true,flowerCalorie);
		//܂ꂽĂȂ̂ōŌォQ߂̈true
		//܂̃CX^X͂̃\bhdeleteȂ

		seedList->addBirthSeed(daughterSeed);
		//V[hXgւ̓o^
		//usedEnergy+=flowerCalorie;
		//Ԃ̑傫GlM[
		doneWork += "sucess";
	}catch(char* errorMessage){
		doneWork+=errorMessage;
		if(newPoint3D){
			delete newPoint3D;
			newPoint3D=NULL;
		}
		energyProcess(breed_flower,usedEnergy);
		return;
	}
	++breedNumber; //܂ꂽ𒲐
	//Ƃ̓GlM[
	energyProcess(breed_flower,usedEnergy);

}

void mCPU::f_error()
{
	doneWork.Format("error happen // ip %d : size%d" ,ip,size);
	//炩̎sĂ
	mDouble keepEnergy=seed->getPartsList()->getCalorie();
	energy->addKeepEnergy(keepEnergy);
	energy->addOperatorEnergy(mCPU::set_flower_number,seed->getPartsList()->getFlowerKeepCalorie());
	energy->addOperatorEnergy(mCPU::set_leaf_number,seed->getPartsList()->getLeafKeepCalorie());
	energy->addOperatorEnergy(mCPU::set_edge_number,seed->getPartsList()->getEdgeKeepCalorie());
	//Ȉێ̂߂ɗpʒm
	energy->addUsedEnergy(keepEnergy);
	//̎sŎgpʒm
	energy->subCurrentEnergy(keepEnergy);
	//݂̃GlM[gĂ

}

void mCPU::energyProcess(mInt index, mDouble operatorEnergyValue)
{
	energy->addOperatorEnergy(index,operatorEnergyValue);
	//߂ŗpʒm
	mDouble keepEnergy=seed->getPartsList()->getKeepCalorie();
	energy->addKeepEnergy(keepEnergy);
	//energy->addKeepEnergy(0.0);
	energy->addOperatorEnergy(mCPU::set_flower_number,seed->getPartsList()->getFlowerKeepCalorie());
	energy->addOperatorEnergy(mCPU::set_leaf_number,seed->getPartsList()->getLeafKeepCalorie());
	energy->addOperatorEnergy(mCPU::set_edge_number,seed->getPartsList()->getEdgeKeepCalorie());
	//Ȉێ̂߂ɗpʒm
	mDouble usedEnergy=operatorEnergyValue+keepEnergy;
	energy->addUsedEnergy(usedEnergy);
	//̎sŎgpʒm
	energy->subCurrentEnergy(usedEnergy);
	//݂̃GlM[gĂ

	//doneWorkɏޕĂ
	CString addString;
	addString.Format("   operator: %.10lf,keep %.10lf,total %.10lf",
		operatorEnergyValue,keepEnergy,usedEnergy);
	doneWork+=addString;
}

vector<mInt> mCPU::searchTemplate()
{
	vector<mInt> template_code; //ev[gR[ḧꎞi[ꏊ
	mInt tempIP=ip+1;
		//ev[gT̍ŏ̈ʒu
	if(tempIP<0 || tempIP>=size){
		return template_code; //ev[gg݂Ȃ
		//̂ƂɕԂ̂̓TCY0vector
	}
	for( ;tempIP<size ;++tempIP){
		mInt tempOP=code[tempIP] ;
		if(tempOP != nop_0 && tempOP != nop_1){
			break; //ev[gp̖߂O
		}
		template_code.push_back(tempOP);
			//ev[gƂēo^
	}
	return template_code;
}

mInt mCPU::searchForward()
{
	//Õev[g̈ʒuT
	//Ԃl͑Õev[g̍Ō
	//i܂Ajump_forwardݒł悤ɂj
	//jump_forward̂Ƃip++邱Ƃɒ
	vector<mInt> template_code=searchTemplate(); //ev[gR[ḧꎞi[ꏊ
	mInt template_size=template_code.size();
	if(template_size==0){
		return -2; //T̎s
	}

	mInt tempIP=ip+template_size+2;
		//ev[gT̍ŏ̈ʒu(ev[g̏I̎)
	if(tempIP<0 || tempIP>size-template_size){
		return -2; //ev[gTӖ
	}
	for( ;tempIP<=size-template_size ;++tempIP){
		int index=0;
		for(vector<mInt>::iterator it=template_code.begin();
			it != template_code.end();
			++it,++index){
				mInt compareOP=code[tempIP+index];
				if( (compareOP == nop_0 && *it == nop_1)
					||(compareOP == nop_1 && *it == nop_0)){
				}else{
					break; //Ƃ炵킹
				}
		} // end of inner 'for' loop
		if(it==template_code.end()){
			//TׂĂ܂sƂ
			//܂TĂR[hƂ
			return tempIP+template_size-1;
			//  -1 ͎ip++Œ邽
		}
	} //end of outer 'for' loop
	return -2; //TɎs
}

mInt mCPU::searchBack()
{
	//̃ev[g̈ʒuT
	//Ԃl͌̃ev[g̍Ō
	//i܂Ajump_backݒł悤ɂj
	//jump_back̂Ƃip++邱Ƃɒ
	vector<mInt> template_code=searchTemplate(); //ev[gR[ḧꎞi[ꏊ
	mInt template_size=template_code.size();
	if(template_size==0){
		return -2; //T̎s
	}

	mInt tempIP=ip-template_size;
		//ev[gT̍ŏ̈ʒu
	if(tempIP<0 || tempIP>size-template_size){
		return -2; //ev[gTӖ
	}
	for( ;tempIP>=0 ;--tempIP){
		int index=0;
		for(vector<mInt>::iterator it=template_code.begin();
			it != template_code.end();
			++it,++index){
				mInt compareOP=code[tempIP+index];
				if( (compareOP == nop_0 && *it == nop_1)
					||(compareOP == nop_1 && *it == nop_0)){
					//Ƃ炵킹
				}else{
					break;
				}
		} // end of inner 'for' loop
		if(it==template_code.end()){
			//TׂĂ܂sƂ
			//܂TĂR[hƂ
			return tempIP+template_size-1;
			//  -1 ͎ip++Œ邽
		}
	} //end of outer 'for' loop
	return -2; //TɎs

}

void mCPU::adjustThetaPhy(mDouble *aTheta, mDouble *aPhy)
{
	// thetaphyɂĂ
	// WX^̒g1ɂ
	// ۂɎgpl 萔 

	*aTheta = registers[theta] * mParameter::mCPU_adjust_theta;
	*aPhy = registers[phy] * mParameter::mCPU_adjust_phy;
}

mPoint3D* mCPU::nextPoint3D(mPoint3D *currentPoint3D)
{
	mPoint3D* returnPoint3D = new mPoint3D;
	returnPoint3D->z=0.0; //̃V[h͒nɂł
	mDouble hight=currentPoint3D->z 
		* mParameter::mCPU_adjust_hight;
	mDouble hight_variance=hight * mParameter::mCPU_hight_variance;
			//łǂꂾԂ̕ςƂȂ
	mDouble r = mSimpleRandom::getNormal(hight,hight_variance);
			//ꂪۂɔԋ
			// ۂɂ́AԂƂA͂ȂꂽƂ낪Ȃ
	mDouble theta = mSimpleRandom::getmValue(-PI,PI);
			// -   ܂ł̈lz
	returnPoint3D->x=r*cos(theta);
	returnPoint3D->y=r*sin(theta);
	return returnPoint3D;
}

mEnergy* mCPU::getEnergy()
{
	return energy;
}

mInt mCPU::getBreedNumber()
{
	return breedNumber;
}

CString mCPU::getDoneWork()
{
	return doneWork;
}

mInt mCPU::getIP()
{
	return ip;
}

mInt mCPU::getRegisterIndex()
{
	return registerIndex;
}

mDouble* mCPU::getRegisters()
{
	return registers;
}


void mCPU::changeGene(mGene *gene)
{
	this->gene = gene;
	code = gene->getCode();
	size = gene->getSize();
}
