// mCPU.h: mCPU NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MCPU_H__136E5F20_1249_11D4_A00F_EB25FC123F33__INCLUDED_)
#define AFX_MCPU_H__136E5F20_1249_11D4_A00F_EB25FC123F33__INCLUDED_

#include "mParameter.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ion.h"
#include "mSuperClass.h"
#include "mSeed.h"
class mSeed;
#include "mGene.h"
class mGene;
#include "mEnergy.h"
class mEnergy;
#include "mPartsList.h"
class mPartsList;

//ꂼ̃V[ĥȂCPU\NX
class mCPU : public mSuperClass  
{
public:
	void changeGene(mGene* gene);
	mDouble* getRegisters();
	mInt getRegisterIndex();
	mInt getIP();
	CString getDoneWork();
	mInt getBreedNumber();
	enum RegisterNames{ //WX^̖O
		r,theta,phy,
			flower_number,leaf_number,
			node_number,edge_number,
			flower_energy,leaf_energy,
			counter
	};
	enum operators{ //ꂼ̃Iy[^
			nop_0,
			nop_1,
			gene_separate,
			if_counter_zero,

			jump_forward,
			jump_back,
			call,
			ret,

			push,
			pop,
			shift_left,
			shift_right,

			increment,
			decrement,
			zero,
			cut_edge,

			set_flower_number,
			set_leaf_number,
			set_flower_energy,
			set_leaf_energy,

			set_node_number,
			set_edge_number,
			set_phy,
			set_theta,

			set_r,
			set_counter,
			make_flower,
			make_leaf,

			make_node,
			grow_flower,
			grow_leaf,
			breed_flower
	};
	mEnergy* getEnergy(); //GlM[ւ̃|C^
	void execute(); //ꂼ̖߂̎s
	void selfSave(ostream& os);
	void selfLoad(istream& is);
	CString toString();
	mCPU(mSeed* seed); //seedpRXgN^i̒gene,code𒲐j
	static const CString OperatorName[]; //߂̖O
	static const CString LongOperatorName[]; //߂̖Oitl[j
	static const CString ShortOperatorName[]; //߂̖OiV[gl[At@Cǂݍݗpj
	static const CString RegisterName[]; //WX^̖O
	static const mInt RegistersNumber; //WX^̐
	static const mInt OperatorNumber; //߂̎ނ̐
	virtual ~mCPU();

private:
	mInt breedNumber; //݂܂łɐ񂾃V[h̐
	mPoint3D* nextPoint3D(mPoint3D* currentPoint3D); //݂̉Ԃ̈ʒuÃV[ḧʒu肷
	void adjustThetaPhy(mDouble* aTheta,mDouble* aPhy); //theta,phỹWX^ےlւ̕ϊ
	mInt searchBack(); //ev[ǧ
	mInt searchForward(); //ev[g̑O
	vector<mInt> searchTemplate() ;// ev[ĝ̌
	void energyProcess(mInt index,mDouble operatorEnergyValue); //GlM[̌㏈p
	mInt size; //genẽTCY
	mPartsList* partsList; //mPartsListւ̃|C^
	map<mInt,void (mCPU::*)()> mapOperator;
	void f_error(); //OperatorNumber Ƀ~X̂߂̕ی 
	void f_breed_flower(); //ԂV[h
	void f_grow_leaf(); //t傫
	void f_grow_flower(); //Ԃ傫
	void f_make_node(); //m[h쐬
	void f_make_leaf(); //t쐬
	void f_make_flower(); //Ԃ쐬
	void f_set_counter(); //WX^countZbg
	void f_set_r(); //WX^rZbg
	void f_set_phy(); //WX^phyZbg
	void f_set_theta(); //WX^thetaZbg
	void f_set_edge_number(); //WX^edge_numberZbg
	void f_set_leaf_number(); //WX^leaf_numberZbg
	void f_set_node_number(); //WX^node_numberZbg
	void f_set_flower_energy(); //WX^flower_energyZbg
	void f_set_leaf_energy(); //WX^leaf_energyZbg
	void f_set_flower_number(); //WX^flower_numberZbg
	void f_cut_edge(); //}
	void f_zero(); //WX^̒g0ɂ
	void f_decrement(); //WX^̒g1炷
	void f_increment(); //WX^̒g1₷
	void f_shift_right(); //WX^̒g2{ɂ
	void f_shift_left(); //WX^̒g𔼕ɂ
	void f_pop(); //WX^̒gpop
	void f_push(); //WX^̒gpush
	void f_ret(); //callĂ񂾃Tu[`return
	void f_call(); //Tu[`R[
	void f_jump_back(); //̃ev[gɃWv
	void f_jump_forward(); //Õev[gɃWv
	void f_if_counter_zero(); //counter0ɋ߂Ύ̖߂s
	void f_gene_separate(); //W[Zp[g
	void f_nop_1(); //no operation 1
	void f_nop_0(); //no operation 0
	mInt* code; //`qR[hւ̒ڃANZX
	mGene* gene; //`qւ̃|C^
	mEnergy* energy; //GlM[Ǘ
	mSeed* seed; //V[hւ̃|C^
	CString doneWork; //O̎de̕ێ
	stack<mDouble>* registerStack; //pushpopp̃X^bN
	stack<mInt>* ipStack; //callretp̃X^bN
	mInt registerIndex; //ݎgpĂ郌WX^
	mInt ip; //instruction pointer
	mDouble* registers; //WX^Q
	mCPU();  //ftHgRXgN^͎gpȂ
};

#endif // !defined(AFX_MCPU_H__136E5F20_1249_11D4_A00F_EB25FC123F33__INCLUDED_)
