// mEnergy.cpp: mEnergy NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mEnergy.h"
#include "mCPU.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mEnergy::mEnergy()
{
	//S 0 ɏ
	currentEnergy=0.0;
	keepEnergy=0.0;
	totalEnergy=0.0;
	usedEnergy=0.0;

	operatorEnergy = NULL ;
		//͕̕ی
	operatorEnergy=new mDouble[mCPU::OperatorNumber];
	for(mInt i=0;i<mCPU::OperatorNumber;++i){
		operatorEnergy[i]=0.0;
	}
}

mEnergy::~mEnergy()
{
	if(operatorEnergy){
		delete[] operatorEnergy;
		operatorEnergy = NULL;
	}
}

CString mEnergy::toString()
{
	CString returnString="energy ";
	for(mInt i=0;i<mCPU::OperatorNumber;++i){
		CString tmpString="";
		tmpString.Format("%.10lf ",operatorEnergy[i]);
		returnString+=tmpString;
	}
	return returnString;
}

void mEnergy::selfLoad(istream &is)
{
	CString comment;
	is>>comment;
	is>> currentEnergy >> keepEnergy 
		>> totalEnergy >> usedEnergy;
	for(mInt i=0;i<mCPU::OperatorNumber;++i){
		is>>operatorEnergy[i];
	}
	is>>comment;
}

void mEnergy::selfSave(ostream &os)
{
	//GlM[̒gĂ
	os<<"/*mEnergy start*/"<<endl;
	os<< currentEnergy <<' '
		<< keepEnergy  <<' '
		<< totalEnergy <<' '
		<< usedEnergy <<endl;
	for(mInt i=0;i<mCPU::OperatorNumber;++i){
		os<<operatorEnergy[i]<<' ';
	}
	os<<endl;
	os<<"/*mEnergy end*/"<<endl;
}

mDouble mEnergy::getCurrentEnergy()
{
	return currentEnergy;
}

void mEnergy::subCurrentEnergy(mDouble value)
{
	currentEnergy-=value;
}

mDouble mEnergy::getTotalEnergy()
{
	return totalEnergy;
}

void mEnergy::addTotalEnergy(mDouble value)
{
	totalEnergy+=value;
	//currentEnergy
	currentEnergy+=value;
}

mDouble mEnergy::getKeepEnergy()
{
	return keepEnergy;
}

void mEnergy::addKeepEnergy(mDouble value)
{
	keepEnergy+=value;
}

mDouble mEnergy::getUsedEnergy()
{
	return usedEnergy;
}

void mEnergy::addUsedEnergy(mDouble value)
{
	usedEnergy+=value;
}

mDouble mEnergy::getOperatorEnergy(mInt index)
{
	//indexԈĂꍇ-1.0IɕԂ
	if(index<0 || index>=mCPU::OperatorNumber){
		return -1.0;
	}
	return operatorEnergy[index];
}

void mEnergy::addOperatorEnergy(mInt index, mDouble value)
{
	//indexԈĂꍇ͋IɕԂ
	if(index<0 || index>=mCPU::OperatorNumber){
		return;
	}
	operatorEnergy[index]+=value;
}

mDouble* mEnergy::getOperatorEnergies()
{
	return operatorEnergy;
}

void mEnergy::addOtherEnergy(mEnergy *energy)
{
	//ׂĂ̗vf
	if(energy==NULL){
		return;
	}
	currentEnergy+=energy->currentEnergy;
	keepEnergy+=energy->keepEnergy;
	totalEnergy+=energy->totalEnergy;
	usedEnergy+=energy->usedEnergy;
	for(mInt i=0;i<mCPU::OperatorNumber;++i){
		operatorEnergy[i]+=energy->operatorEnergy[i];
	}

}

void mEnergy::divideByNumber(mInt number)
{
	//ׂĂ̗vfiς߂̂Ɏgj
	if(number<=0){
		return;
	}
	currentEnergy /= (mDouble)number;
	keepEnergy /= (mDouble)number;
	totalEnergy /= (mDouble)number;
	usedEnergy /= (mDouble)number;
	for(mInt i=0;i<mCPU::OperatorNumber;++i){
		operatorEnergy[i] /= (mDouble)number;
	}

}

void mEnergy::initialEnergy()
{
	//ׂ 0 ɖ߂
	currentEnergy = 0.0;
	keepEnergy = 0.0;
	totalEnergy = 0.0;
	usedEnergy = 0.0;
	for(mInt i=0;i<mCPU::OperatorNumber;++i){
		operatorEnergy[i] = 0.0;
	}
}

CString mEnergy::makeString()
{
	CString newString,addString;

	addString.Format("edge %.10lf\x0d\x0a",calculateEdgeEnergy());
	newString += addString;
	addString.Format("leaf %.10lf\x0d\x0a",calculateLeafEnergy());
	newString += addString;
	addString.Format("flower %.10lf\x0d\x0a",calculateFlowerEnergy());
	newString += addString;

	newString +="\x0d\x0a";

	addString.Format("current %.10lf\x0d\x0a",currentEnergy);
	newString += addString;
	addString.Format("total %.10lf\x0d\x0a",totalEnergy);
	newString += addString;
	addString.Format("used %.10lf\x0d\x0a",usedEnergy);
	newString += addString;
	addString.Format("keep %.10lf\x0d\x0a",keepEnergy);
	newString += addString;

	newString += "\x0d\x0a";

	for(mInt i = 0 ;i<mCPU::OperatorNumber ;++i){
		addString.Format("%s %.10lf\x0d\x0a",mCPU::OperatorName[i],operatorEnergy[i]);
		newString += addString;
	}
	
	return newString;
}

mDouble mEnergy::calculateEdgeEnergy()
{
	return operatorEnergy[mCPU::set_edge_number]
		+ operatorEnergy[mCPU::cut_edge]
		+ operatorEnergy[mCPU::make_node]
		;
}

mDouble mEnergy::calculateLeafEnergy()
{
	return operatorEnergy[mCPU::set_leaf_number]
		+ operatorEnergy[mCPU::set_leaf_energy]
		+ operatorEnergy[mCPU::make_leaf]
		+ operatorEnergy[mCPU::grow_leaf]
		;
}

mDouble mEnergy::calculateFlowerEnergy()
{
	return operatorEnergy[mCPU::set_flower_number]
		+ operatorEnergy[mCPU::set_flower_energy]
		+ operatorEnergy[mCPU::make_flower]
		+ operatorEnergy[mCPU::grow_flower]
		+ operatorEnergy[mCPU::breed_flower]
		;
}
