// mField.cpp: mField NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mField.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mField::mField()
{
	//gȂ
}

mField::mField(mDaughter *daughter)
{
	this->daughter = daughter; //̃CX^X͂̃NXdeleteȂ
	capacity = 0.0;
	overCapacity = 0.0;
	totalEnergy = 0.0;

	fieldMatrix = NULL;
	fieldMatrix = new mDouble*[mParameter::mField_N];
	for(mInt i=0;i<mParameter::mField_N;++i){
		fieldMatrix[i] = new mDouble[mParameter::mField_N];
	}
		//͂Ƃ̃NX̃fXgN^delete邱
}

mField::~mField()
{
	if(fieldMatrix){
		for(mInt i=0;i<mParameter::mField_N;++i){
			if(fieldMatrix[i]){
				delete[] fieldMatrix[i];
				fieldMatrix[i] = NULL;
			}
		}
		delete[] fieldMatrix;
		fieldMatrix = NULL;
	}
}

CString mField::toString()
{
	if(daughter){
		return CString("Field of ")+daughter->toString();
	}
	return "Field with noname ";
}

void mField::selfLoad(istream &is)
{
	CString comment;
	is >> comment;
	is >> capacity 
		>> overCapacity
		>> totalEnergy;
	is >> comment;
}

void mField::selfSave(ostream &os)
{
	os << "/*mField start*/"<< endl;
	os << capacity << ' '
		<< overCapacity <<' '
		<< totalEnergy <<endl;
	os << "/*mField end*/"<<endl;
}


bool mField::isInner(mPoint3D *point3D)
{
	if(point3D == NULL){
		// NULLȂĂȂƂɂ
		return false;
	}
	const mDouble max_x = mParameter::mField_min_x + mParameter::mField_haba*(mDouble)mParameter::mField_N;
	const mDouble max_y = mParameter::mField_min_y + mParameter::mField_haba*(mDouble)mParameter::mField_N;

	if(point3D->z < 0.0){
		//nʂɖ܂Ă
		return false;
	}
	
	const mDouble x = point3D->x;
	if(x < mParameter::mField_min_x || x>max_x ){
		// OɏoĂ
		return false;
	}
	const mDouble y = point3D->y;
	if(y < mParameter::mField_min_y || y>max_y ){
		// OɏoĂ
		return false;
	}
	//܂łΓĂ邱ƂɂȂ
	return true;

}

mDouble mField::getCapacity()
{
	return capacity;
}

void mField::calculateSun()
{
	if(fieldMatrix == NULL){
		return;
	}
	vector<mFlowerLeaf*>* targetVector = getSortedList();
		//̃CX^X͂̃\bhdelete邱
	if(targetVector == NULL){
		return;
	}
	const mInt N = mParameter::mField_N;
	for(mInt i=0; i < N ;++i){
		for(mInt j=0; j < N;++j){
			fieldMatrix[i][j]=mParameter::mField_daylight;
				//̊iqɃGlM[^
		}
	}
	for(vector<mFlowerLeaf*>::iterator itTarget = targetVector->begin();
			itTarget != targetVector->end();
			++itTarget){
		if((*itTarget)->getCenterPoint3D()->z < 0.0){
			break;
		}
			//0.0̂Ƃɂ̓GlM[^Ȃ
		giveSun(*itTarget);
		//̗vfɃGlM[^
	}
	vector<mSeed*>* seedVector = daughter->getSeedList()->getSeedVector();
	vector<mSeed*>::iterator itSeed;
	for(itSeed = seedVector->begin();
			itSeed != seedVector->end();
			++itSeed){
		mPartsList* partsList = (*itSeed)->getPartsList();
			//̃CX^X͂̃\bhŏȂ
		partsList->calculateAggregateEnergy();
		partsList->calculateAggregateFlowerEnergy();
			//ŏW߂GlM[W񂵂Ă
	}
	//vZÎdeleteĂ
	targetVector->clear();
	delete targetVector;

	mDouble residualEnergy = 0.0;
	//cĂGlM[vZ
	for(i=0; i < N ;++i){
		for(mInt j=0; j < N;++j){
			residualEnergy += fieldMatrix[i][j];
				//̊iqGlM[󂯎
		}
	}
	mDouble currentTotalEnergy = mParameter::mField_daylight*(mDouble)N*(mDouble)N;
	capacity = 1.0 - residualEnergy / currentTotalEnergy;
	//ꂪL
	totalEnergy +=	currentTotalEnergy;

	overCapacity = capacity/mParameter::mField_capacity - 1.0;
	if(overCapacity < 0.0){
		overCapacity = 0.0;
	}
	//ꂪI[o[Ă镪
}

bool mField::capacityOver()
{
	if(capacity>mParameter::mField_capacity){
		//Lel𒴂Ă
		return true;
	}
	return false;
}

mDouble mField::adjustCapacity()
{
	return overCapacity;
}

vector<mFlowerLeaf*>* mField::getSortedList()
{
	vector<mFlowerLeaf*>* targetVector = new vector<mFlowerLeaf*>;
		//̃CX^XcalculateSundelete邱
	vector<mSeed*>* seedVector = daughter->getSeedList()->getSeedVector();
	vector<mFlower*>* flowerVector ;
	vector<mLeaf*>* leafVector ;
	vector<mSeed*>::iterator itSeed;
	vector<mFlower*>::iterator itFlower;
	vector<mLeaf*>::iterator itLeaf;

	for(itSeed = seedVector->begin();
			itSeed != seedVector->end();
			++itSeed){
		flowerVector = (*itSeed)->getPartsList()->getFlowerList();
		leafVector = (*itSeed)->getPartsList()->getLeafList();
		for(itFlower = flowerVector->begin();
				itFlower != flowerVector->end();
				++itFlower){
			targetVector->push_back(*itFlower);
		}
		for(itLeaf = leafVector->begin();
				itLeaf != leafVector->end();
				++itLeaf){
			targetVector->push_back(*itLeaf);
		}
	} //end of for, itSeed

	//Ƀ\[g
	sort(targetVector->begin(),targetVector->end(),mFlowerLeaf::higherThan);
	return targetVector;
}

void mField::giveSun(mFlowerLeaf *target)
{
	if(fieldMatrix == NULL){
		return;
	}
	const mDouble center_x = target->getCenterPoint3D()->x;
	const mDouble center_y = target->getCenterPoint3D()->y;
	const mDouble radius = target->getRadius();
	const mDouble haba = mParameter::mField_haba;
	const mDouble downsize = mParameter::mField_downsize;

	const mDouble min_x = mParameter::mField_min_x;
	const mDouble min_y = mParameter::mField_min_y;

	mInt min_i = (mInt)((center_x-radius-min_x)/haba-0.5);
		//x̍ŏCfbNX
	mInt max_i = (mInt)((center_x+radius-min_x)/haba-0.5);
	mInt min_j = (mInt)((center_y-radius-min_y)/haba-0.5);
	mInt max_j = (mInt)((center_y+radius-min_y)/haba-0.5);

	if(min_i<0){
		min_i=0;
	}
	if(max_i >= mParameter::mField_N){
		max_i = mParameter::mField_N-1;
	}
	if(min_j<0){
		min_j=0;
	}
	if(max_j >= mParameter::mField_N){
		max_j = mParameter::mField_N-1;
	}
		//CfbNXOɏoȂ
	mDouble value = 0.0;
		//valueɑŜW܂͂
	for(mInt i = min_i;i <= max_i;++i){
		for(mInt j = min_j;j <= max_j;++j){
			mDouble x = min_x+((mDouble)i+0.50)*haba;
			mDouble y = min_y+((mDouble)j+0.50)*haba;
			mDouble dif_x = center_x-x;
			mDouble dif_y = center_y-y;
			if(dif_x*dif_x+dif_y*dif_y < radius*radius){
				//̕ŉԂtdȂĂ
				value += fieldMatrix[i][j]*downsize;
					//̕Ԃt͎󂯎
				fieldMatrix[i][j]*=(1.0-downsize);
					//Ă܂vZĂ
			}			
		} //end of for,j
	} // end of for,i

	target->setLightEnergy(value);
}

mDouble mField::getTotalEnergy()
{
	return totalEnergy;
}

void mField::saveBirdView(ostream &os)
{
	const mDouble min_x = mParameter::mField_min_x;
	const mDouble min_y = mParameter::mField_min_y;
	const mDouble haba = mParameter::mField_haba;
	const mDouble max_x = min_x + 
		 haba * mParameter::mField_N;
	const mDouble max_y = min_y + 
		haba * mParameter::mField_N;

	const mDouble center_x = (max_x+min_x)/2.0;
	const mDouble center_y = (max_y+min_y)/2.0;

	os << min_x << ' ' << min_x << ' ' <<
		max_x << ' ' << max_y << ' '<<
		center_x << ' ' << center_y << ' ' <<
		haba << endl;
}

mDouble mField::calculate_center_x()
{
	const mDouble min_x = mParameter::mField_min_x;
	const mDouble haba = mParameter::mField_haba;
	const mDouble max_x = min_x + 
		 haba * mParameter::mField_N;
	const mDouble center_x = (max_x+min_x)/2.0;
	return center_x;
}

mDouble mField::calculate_center_y()
{
	const mDouble min_y = mParameter::mField_min_y;
	const mDouble haba = mParameter::mField_haba;
	const mDouble max_y = min_y + 
		haba * mParameter::mField_N;
	const mDouble center_y = (max_y+min_y)/2.0;
	return center_y;
}
