// mGeneVector.cpp: mGeneVector NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mGeneVector.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

mGeneVector::mGeneVector(mGeneList* geneList,mInt size)
{
	this->geneList = geneList;
	this->size = size;
	genes = NULL;
	genes = new vector<mGene*>;
	//̃CX^X͒g܂߂
	//̃NXdelete邱
}

mGeneVector::mGeneVector(mGeneList* geneList)
{
	this->geneList = geneList;
	this->size = 0;//_~[̏
	genes = NULL;
	genes = new vector<mGene*>;
	//̃CX^X͒g܂߂
	//̃NXdelete邱
}

mGeneVector::~mGeneVector()
{
	if(genes){
		for(vector<mGene*>::iterator itGene = genes->begin();
				itGene != genes->end();
				++itGene){
			if(*itGene){
				delete *itGene;
				*itGene = NULL;
			}
		}
		delete genes;
		genes = NULL;
	}
}

void mGeneVector::selfSave(ostream &os)
{
	os << "/*mGeneVector start*/" << endl;
	os << size <<' '<<
		genes->size() <<endl;
	for(vector<mGene*>::iterator itGene = genes->begin();
			itGene != genes->end();
			++itGene){
		(*itGene)->selfSave(os);
	}
	os <<'0'<<endl; //dummy
	os << "/*mGeneVector end*/" << endl;
}

void mGeneVector::selfLoad(istream &is)
{
	CString comment;
	is >> comment;
	mInt genesNumber;
	is >> size >>
		genesNumber;
	for(mInt i=0 ; i<genesNumber ; ++i){
		mGene* newGene = new mGene(geneList);
		newGene->selfLoad(is);
		genes->push_back(newGene);
	}
	mInt dummy;
	is >> dummy;
	is >> comment;

}

mInt mGeneVector::getGeneNumber()
{
	if(genes){
		return genes->size();
	}
	return 0;
}

bool mGeneVector::decideID(mGene *daughterGene, mID **newID, mGene **gene)
{
	*newID = NULL;
	*gene = NULL;
		//Ԃl݂Ȃ̂珉Ă
	if(size != daughterGene->getSize()){
		//TCYႤ񂾂猩Ȃ
		return false;
	}
	for(vector<mGene*>::iterator itGene = genes->begin();
			itGene != genes->end();
			++itGene){
		if((*itGene)->compareTo(daughterGene)){
			//𔭌
			*newID = (*itGene)->getID();
			*gene = *itGene;
				//̓AhXRs[Ƃ
			return true; //݂
		}
	}
	return false;//݂Ȃ

}

void mGeneVector::addNewGene(mGene *newGene)
{
	if(genes == NULL || newGene == NULL){
		return;
	}
	if(find(genes->begin(),genes->end(),newGene)!=genes->end()){
		//łɓo^Ăgeneł邩o^Ȃ
		return;
	}
	genes->push_back(newGene);
}

mInt mGeneVector::getSize()
{
	return size;
}

mGene* mGeneVector::getGene(mID *ID)
{
	if(ID->getSize() != size){
		//TCY炵ĈႤ
		return NULL;
	}
	for(vector<mGene*>::iterator itGene = genes->begin();
			itGene != genes->end();
			++itGene){
		if((*itGene)->getID()->compareTo(ID)){
			//𔭌
			return *itGene;
		}
	}
	return NULL; //Ȃ
}

void mGeneVector::deleteGene(mGene *oldGene)
{
	if(oldGene==NULL){
		return;
	}
	if(oldGene->getSize() != size){
		return;
	}
	for(vector<mGene*>::iterator itGene = genes->begin();
			itGene != genes->end();
			++itGene){
		if((*itGene)==oldGene){
			//𔭌
			delete *itGene; //ŗvȂȂgenedelete
			genes->erase(itGene);
			return;
		}
	}
	return;
}

void mGeneVector::getSeedsList(vector<mSeed*>* seedList)
{
	for(vector<mGene*>::iterator itGene = genes->begin();
			itGene != genes->end();
			++itGene){
		if(*itGene){
			vector<mSeed*>* sList = (*itGene)->getSeeds();
			for(vector<mSeed*>::iterator itSeed = sList->begin();
					itSeed != sList->end();
					++itSeed){
				seedList->push_back(*itSeed);
			}
		}
	}
	return;

}

int mGeneVector::getSeedNumber()
{
	int count = 0;
	for(vector<mGene*>::iterator itGene = genes->begin();
			itGene != genes->end();
			++itGene){
		if(*itGene){
			count += (*itGene)->getSeedNumber();
		}
	}
	return count;
}

vector<mGene*>* mGeneVector::getGenes()
{
	return genes;
}
