// mPartsList.cpp: mPartsList NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Ion.h"
#include "mPartsList.h"
#include "mField.h"
#include "mSeedList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////



mPartsList::~mPartsList()
{
	freeList(); //Xg̍폜
}

mPartsList::mPartsList(mSeed *seed, CString initalABuffer="N")
{
	this->seed=seed;
	ABuffer=initalABuffer;
	flowerList=NULL;
	leafList=NULL;
	nodeList=NULL;
	edgeList=NULL;
	rebuild(seed->getCenterPoint3D()); //Xg̍\z
	aggregateEnergyFlower = 0.0;
	aggregateEnergyValue = 0.0;
}

CString mPartsList::toString()
{
	return CString("PartsList ")+ABuffer+' '+seed->toString();
}

void mPartsList::selfLoad(istream &is)
{
	CString comment;
	is>>comment;
	is>>ABuffer;
	is>>aggregateEnergyValue ;
	is>>aggregateEnergyFlower ;
	is>>comment;

	//ABuffer̓e烊Xg𐶐
	rebuild(seed->getCenterPoint3D());
}

void mPartsList::selfSave(ostream &os)
{
	os<<"/*mPartsList start*/"<<endl;
	os<<ABuffer<<endl;
	os <<aggregateEnergyValue <<endl;
	os <<aggregateEnergyFlower << endl;
	os<<"/*mPartsList end*/"<<endl;
}

vector<mFlower*>* mPartsList::getFlowerList() //Ԃ̂߂̃Xg𓾂
{
	return flowerList;
}

vector<mLeaf*>* mPartsList::getLeafList() //t̂߂̃Xg𓾂
{
	return leafList;
}

vector<mEdge*>* mPartsList::getEdgeList() //}̂߂̃Xg𓾂
{
	return edgeList;
}
vector<mNode*>* mPartsList::getNodeList() //m[ĥ߂̃Xg𓾂
{
	return nodeList;
}

bool mPartsList::make_flower(mInt nodeNumber, mDouble energy, mDouble r, mDouble theta, mDouble phy)
{
	if(check_energy(r,energy)==false){
		//܂ɂdȂƂ͂Ȃ
		return false;
	}
	//܂Node肷
	if(nodeList->size() <= 0 || nodeNumber<0){
		//node̐w肳ꂽ̂̕傫
		return false;
	}
	nodeNumber %= nodeList->size();

	mNode* targetNode=*(nodeList->begin()+nodeNumber); //̃CX^X͂̃\bhdeleteȂ
							//킩₷Oɂ

	mPoint3D* targetNodePoint3D=targetNode->getCenterPoint3D();
	mPoint3D* vectorToFlower=makePoint3D(r,theta,phy);
	mPoint3D* flowerPoint3D = mPoint3D::addPoint3D(targetNodePoint3D,vectorToFlower);
			//̃CX^X͂Ə
	mDouble radius=mFlower::calculateRadius(energy);
	CString newString;
	newString.Format("(NE<%.10lf,%.10lf,%.10lf>F<%.10lf>)",
		vectorToFlower->x,vectorToFlower->y,vectorToFlower->z,radius);
	delete vectorToFlower;
	//}镶̍쐬
	//܂łŁAԂ̒Sǂɂł̂
	if(mField::isInner(flowerPoint3D)==false){
		//tB[h̊Oɏo邩玸s
		delete flowerPoint3D;
		return false;
	}
	if(canMake(targetNodePoint3D,flowerPoint3D,radius)==false){
		//ԂƂɂ͍Ȃ
		delete flowerPoint3D;
		return false;
	}
	
	//ԂƂɂԂ̂ȂׂĂ
	//܂łŉԂʒuȂǂ肵̂
	//Ԃ
	mFlower* newFlower=new mFlower(seed,flowerPoint3D,radius);
	mEdge* newEdge=new mEdge(seed,targetNodePoint3D,flowerPoint3D);

	//烊Xg̒
	//ABuffer̒
	const mInt nodeIndex = searchIndex('N',nodeNumber);
	//VԂƎ}Xgɓo^
	flowerList->insert(flowerList->begin()+countChar('F',nodeIndex),newFlower);
	edgeList->insert(edgeList->begin()+countChar('E',nodeIndex),newEdge);

	ABuffer.Delete(nodeIndex); //N̕
	ABuffer.Insert(nodeIndex,newString);
	return true;
}

bool mPartsList::make_leaf(mInt nodeNumber, mDouble energy, mDouble r, mDouble theta, mDouble phy)
{
	if(check_energy(r,energy)==false){
		//܂ɂdȂƂ͂Ȃ
		return false;
	}
	//܂Node肷
	if(nodeList->size() <= 0 || nodeNumber<0){
		//node̐w肳ꂽ̂̕傫
		return false;
	}
	nodeNumber %= nodeList->size();
	mNode* targetNode=*(nodeList->begin()+nodeNumber); //̃CX^X͂̃\bhdeleteȂ
							//킩₷Oɂ

	mPoint3D* targetNodePoint3D=targetNode->getCenterPoint3D();
	mPoint3D* vectorToLeaf=makePoint3D(r,theta,phy);
	mPoint3D* leafPoint3D = mPoint3D::addPoint3D(targetNodePoint3D,vectorToLeaf);
		//̃CX^X͂̃\bhȂłƏ
	mDouble radius=mLeaf::calculateRadius(energy);
	CString newString;
	newString.Format("(NE<%.10lf,%.10lf,%.10lf>L<%.10lf>)",
		vectorToLeaf->x,vectorToLeaf->y,vectorToLeaf->z,radius);
	delete vectorToLeaf;
	//܂łŁAԂ̒Sǂɂł̂
	if(mField::isInner(leafPoint3D)==false){
		//tB[h̊Oɏo邩玸s
		delete leafPoint3D;
		return false;
	}
	if(canMake(targetNodePoint3D,leafPoint3D,radius)==false){
		//Ԃ邩Ȃ
		delete leafPoint3D;
		return false;
	}
	
	//܂łŉԂʒuȂǂ肵̂
	//Ԃ
	mLeaf* newLeaf=new mLeaf(seed,leafPoint3D,radius);
	mEdge* newEdge=new mEdge(seed,targetNodePoint3D,leafPoint3D);
	//烊Xg̒
	//ABuffer̒

	const mInt nodeIndex = searchIndex('N',nodeNumber);
	//VtƎ}Xgɓo^
	leafList->insert(leafList->begin()+countChar('L',nodeIndex),newLeaf);
	edgeList->insert(edgeList->begin()+countChar('E',nodeIndex),newEdge);

	ABuffer.Delete(nodeIndex); //N̕
	ABuffer.Insert(nodeIndex,newString);
	return true;
}

bool mPartsList::make_node(mInt nodeNumber, mDouble r, mDouble theta, mDouble phy)
{
	if(check_energy(r,0.0)==false){
		return false;
	}
	//܂Node肷
	if(nodeList->size() <= 0 || nodeNumber<0){
		//node̐w肳ꂽ̂̕傫
		return false;
	}
	nodeNumber %= nodeList->size();
	mNode* targetNode=*(nodeList->begin()+nodeNumber); //̃CX^X͂̃\bhdeleteȂ
							//킩₷Oɂ

	mPoint3D* targetNodePoint3D=targetNode->getCenterPoint3D();
		//̃CX^X͂̃\bhȂdeleteȂ
	mPoint3D* vectorToNode=makePoint3D(r,theta,phy);
		//̃CX^X͂̃\bhȂdelete邱
	mPoint3D* nodePoint3D = mPoint3D::addPoint3D(targetNodePoint3D,vectorToNode);
		//̃CX^X͂̃\bhȂdeleteȂ
	CString newString;
	newString.Format("(NE<%.10lf,%.10lf,%.10lf>N)",
		vectorToNode->x,vectorToNode->y,vectorToNode->z);
	delete vectorToNode;
	//܂łŁAԂ̒Sǂɂł̂
	if(mField::isInner(nodePoint3D)==false){
		//tB[h̊Oɏo邩玸s
		delete nodePoint3D;
		return false;
	}
	//ŁAm[hƃm[hȂ}ɂԂ邩𒲂ׂĂ
	if(canMake(targetNodePoint3D,nodePoint3D,-1.0)==false){
		//Ԃ邩Ȃ
		delete nodePoint3D;
		return false;
	}

	//܂łŃm[hʒuȂǂ肵̂
	//m[h
	mNode* newNode=new mNode(seed,nodePoint3D);
	mEdge* newEdge=new mEdge(seed,targetNodePoint3D,nodePoint3D);
	//烊Xg̒
	//ABuffer̒

	const mInt nodeIndex = searchIndex('N',nodeNumber);
	//Vm[hƎ}Xgɓo^
	nodeList->insert(nodeList->begin()+nodeNumber+1,newNode);
	edgeList->insert(edgeList->begin()+countChar('E',nodeIndex),newEdge);

	ABuffer.Delete(nodeIndex); //N̕
	ABuffer.Insert(nodeIndex,newString);
	return true;
}

bool mPartsList::grow_flower(mInt flowerNumber, mDouble energy)
{
	if(check_energy(energy)==false){
		//܂ɂdȂƂ͂Ȃ
		return false;
	}
	//܂ŏɃ^[QbgƂȂԂ肷
	if(flowerList->size() <=0 || flowerNumber<0){
		//flower̐w肳ꂽ̂̕傫
		return false;
	}
	flowerNumber %= flowerList->size();
	mFlower* targetFlower=*(flowerList->begin()+flowerNumber); //₷邽߂ł
						//̃CX^X͏Ă͍sȂ
	mDouble currentEnergy=targetFlower->getCalorie();
	mDouble nextRadius=mFlower::calculateRadius(currentEnergy+energy);
	mPoint3D* flowerPoint3D=targetFlower->getCenterPoint3D();
				//̃|C^͂̃\bhłdeletełȂ
	//傫ƂɂԂ̂ǂ𔻒肷
	if(canMake(NULL,flowerPoint3D,nextRadius)==false){
		return false;
	}
	
	//܂łő傫ĂƉ
	//ۂɑ傫
	targetFlower->setRadius(nextRadius);
	//ƂABuffer̒
	// F<...>̂Ƃ<...>΂悭
	mInt flowerIndex = searchIndex('F',flowerNumber);
	cutStringRadius(flowerIndex);
		//]ȂƂ폜
	CString newString;
	newString.Format("F<%.10lf>",nextRadius);
	ABuffer.Insert(flowerIndex,newString);
	return true;
}

bool mPartsList::grow_leaf(mInt leafNumber, mDouble energy)
{
	if(check_energy(energy)==false){
		//܂ɂdȂƂ͂Ȃ
		return false;
	}
	//܂ŏɃ^[QbgƂȂԂ肷
	if(leafList->size() <=0 || leafNumber<0){
		//leaf̐w肳ꂽ̂̕傫
		return false;
	}
	leafNumber %= leafList->size();
	mLeaf* targetLeaf=*(leafList->begin()+leafNumber); //₷邽߂ł
						//̃CX^X͏Ă͍sȂ
	mDouble currentEnergy=targetLeaf->getCalorie();
	mDouble nextRadius=mLeaf::calculateRadius(currentEnergy+energy);
	mPoint3D* leafPoint3D=targetLeaf->getCenterPoint3D();
				//̃|C^͂̃\bhłdeletełȂ
	//傫ƂɂԂ̂ǂ𔻒肷
	if(canMake(NULL,leafPoint3D,nextRadius)==false){
		return false;
	}
	
	//܂łő傫ĂƉ
	//ۂɑ傫
	targetLeaf->setRadius(nextRadius);
	//ƂABuffer̒
	// L<...>̂Ƃ<...>΂悭
	mInt leafIndex = searchIndex('L',leafNumber);
	cutStringRadius(leafIndex);
		//]ȂƂ폜
	CString newString;
	newString.Format("L<%.10lf>",nextRadius);
	ABuffer.Insert(leafIndex,newString);
	return true;
}

bool mPartsList::cut_edge(mInt edgeNumber)
{
	//edgeNumber̃`FbNĂ
	if(edgeList->size() <=0 || edgeNumber<0){
		//flower̐w肳ꂽ̂̕傫
		return false;
	}
	edgeNumber %= edgeList->size();

	const mInt edgeIndex = searchIndex('E',edgeNumber);
	vector<mFlower*>::iterator itFlower = flowerList->begin()+countChar('F',edgeIndex);
	vector<mLeaf*>::iterator itLeaf = leafList->begin()+countChar('L',edgeIndex);
	vector<mNode*>::iterator itNode = nodeList->begin()+countChar('N',edgeIndex);
	vector<mEdge*>::iterator itEdge = edgeList->begin()+edgeNumber;

	mInt index = edgeIndex;
	//indexɑΏۂɂȂ 'E' 
	//炱 'E' 𐶐Ă ')' ܂ł
	//
	for(int t=0; t!=1 && index<ABuffer.GetLength() ; ++index){
		switch(ABuffer.GetAt(index)){
		case '(':
			--t;
			break;
		case ')':
			++t;
			break;
		case 'F':
			delete *itFlower;
			*itFlower=NULL;
			flowerList->erase(itFlower);
			break;
		case 'L':
			delete *itLeaf;
			*itLeaf=NULL;
			leafList->erase(itLeaf);
			break;
		case 'N':
			delete *itNode;
			*itNode=NULL;
			nodeList->erase(itNode);
			break;
		case 'E':
			delete *itEdge;
			*itEdge=NULL;
			edgeList->erase(itEdge);
			break;
		} // end of switch
	}// end of for
	//܂ł̕Ă
	ABuffer.Delete(edgeIndex,index-edgeIndex);
		//index ')'ꕶɐił邱Ƃɒ
	//x͔΂ɐi '('폜
	index = edgeIndex - 1;
	for(t=0; t!=-1 && index >=0 ; --index){
		switch(ABuffer.GetAt(index)){
		case '(':
			--t;
			break;
		case ')':
			++t;
			break;
		default:
			break;
		} // end of switch
	} // end of for
	ABuffer.Delete(index+1);
		//ꕶO܂Ŗ߂Ă̂
		//폜
	return true; //ɍ폜
}

bool mPartsList::zero_flower(mInt flowerNumber)
{
	//܂ŏɃ^[QbgƂȂԂ肷
	if(flowerList->size() <=0 || flowerNumber<0){
		//flower̐w肳ꂽ̂̕傫
		return false;
	}
	flowerNumber %= flowerList->size();
	mFlower* targetFlower=*(flowerList->begin()+flowerNumber); //₷邽߂ł
						//̃CX^X͏Ă͍sȂ
	mPoint3D* flowerPoint3D=targetFlower->getCenterPoint3D();
				//̃|C^͂̃\bhłdeletełȂ
	//܂łő傫ĂƉ
	//ۂɏ
	targetFlower->setRadius(0.0);
	//ƂABuffer̒
	// F<...>̂Ƃ<...>΂悭
	mInt flowerIndex = searchIndex('F',flowerNumber);
	cutStringRadius(flowerIndex);
		//]ȂƂ폜
	CString newString;
	newString.Format("F<%.10lf>",0.0);
	ABuffer.Insert(flowerIndex,newString);
	return true;
}

bool mPartsList::canMakeBowl(mPoint3D *otherCenterPoint3D, mDouble radius)
{
	//ԂĂȂǂ
	//ԂƗtƎ}̂ꂼ̃Xgɕ
	for(vector<mFlower*>::iterator itFlower = flowerList->begin();
			itFlower!=flowerList->end();++itFlower){
		if((*itFlower)->canMakeBowl(otherCenterPoint3D,radius) ==false){
			return false;
		}
	}
	for(vector<mLeaf*>::iterator itLeaf = leafList->begin();
			itLeaf!=leafList->end();++itLeaf){
		if((*itLeaf)->canMakeBowl(otherCenterPoint3D,radius) ==false){
			return false;
		}
	}
	for(vector<mEdge*>::iterator itEdge = edgeList->begin();
			itEdge!=edgeList->end();++itEdge){
		if((*itEdge)->canMakeBowl(otherCenterPoint3D,radius) ==false){
			return false;
		}
	}
	return true; //ǂɂԂĂȂ
		//邱Ƃł
}

bool mPartsList::canMakeEdge(mPoint3D *otherCenterPoint3D, mPoint3D *otherEndPoint3D)
{
	//ԂĂȂǂ
	//ԂƗtƎ}̂ꂼ̃Xgɕ
	for(vector<mFlower*>::iterator itFlower = flowerList->begin();
			itFlower!=flowerList->end();++itFlower){
		if((*itFlower)->canMakeEdge(otherCenterPoint3D,otherEndPoint3D) ==false){
			return false;
		}
	}
	for(vector<mLeaf*>::iterator itLeaf = leafList->begin();
			itLeaf!=leafList->end();++itLeaf){
		if((*itLeaf)->canMakeEdge(otherCenterPoint3D,otherEndPoint3D) ==false){
			return false;
		}
	}
	// }m͏Փ˂ȂƂɂȂĂ
	return true; //ǂɂԂĂȂ
		//邱Ƃł
}

void mPartsList::rebuild(mPoint3D *centerPoint3D)
{
	//Ƃ肠ׂĉč蒼
	freeList();
	flowerList = new vector<mFlower*>;
	leafList = new vector<mLeaf*>;
	edgeList = new vector<mEdge*>;
	nodeList = new vector<mNode*>;

	if(centerPoint3D == NULL){
		return;
	}
	mPoint3D* currentPoint3D = new mPoint3D(*centerPoint3D);
	//ł̓Rs[RXgN^gē
	//ʂ̂̂ɂĂ邩Ã\bh
	//currentPointdelete
	stack<mPoint3D*> pointStack;
	//|CgꎞIɔĂ
	mInt index;
	mInt nextIndex;
	const mInt length=ABuffer.GetLength();
	CString tmpString;
	mDouble radius;
	for(index = 0; index < length; ++index){
		switch(ABuffer.GetAt(index)){
		case 'F':
			{
				index+=2; // for 'F<'
				nextIndex = index;
				while(ABuffer.GetAt(nextIndex)!='>'){
					++nextIndex;
				}
				tmpString = ABuffer.Left(nextIndex).Right(nextIndex-index);
				index = nextIndex;
				sscanf(tmpString.operator LPCTSTR( ),"%lf",&radius);
#if ERROR_CHECK
				if(canMake(NULL,currentPoint3D,radius)==false){
					//ԂĂ܂čȂ
					break;
				}
#endif
				mFlower* newFlower=new mFlower(seed,currentPoint3D,radius);
				//̃CX^X̓Xgɓo^̂
				//̃\bhłdeleteȂ
				flowerList->push_back(newFlower);
				break;
			}
		case 'L':
			{
				index+=2; // for 'L<'
				nextIndex = index;
				while(ABuffer.GetAt(nextIndex)!='>'){
					++nextIndex;
				}
				tmpString = ABuffer.Left(nextIndex).Right(nextIndex-index);
				index = nextIndex;
				sscanf(tmpString.operator LPCTSTR( ),"%lf",&radius);
#if ERROR_CHECK
				if(canMake(NULL,currentPoint3D,radius)==false){
					//ԂĂ܂čȂ
					break;
				}
#endif
				mLeaf* newLeaf=new mLeaf(seed,currentPoint3D,radius);
				//̃CX^X̓Xgɓo^̂
				//̃\bhłdeleteȂ
				leafList->push_back(newLeaf);
				break;
			}
			
		case 'N':
			{
				//m[h͈ʒuœł邩sscanf͕KvȂ
				mNode* newNode=new mNode(seed,currentPoint3D);
				nodeList->push_back(newNode);
				break;
			}
			
		case 'E':
			{
				//}̂Ƃ́A}g̈ʒuvZ
				//currentPoint3Dړ邱ƂYȂ悤
				index+=2; // for 'E<'
				nextIndex = index;
				while(ABuffer.GetAt(nextIndex)!='>'){
					++nextIndex;
				}
				tmpString = ABuffer.Left(nextIndex).Right(nextIndex-index);
				index = nextIndex;
				mDouble x,y,z;
				sscanf(tmpString.operator LPCTSTR( ),"%lf,%lf,%lf",&x,&y,&z);
				mPoint3D* newPoint3D = new mPoint3D(
						x + currentPoint3D->x,
						y + currentPoint3D->y,
						z + currentPoint3D->z);
#if ERROR_CHECK  //Ƃ肠܂łĂꍇ͂͂
				if(mField::isInner(newPoint3D)==false
					|| canMake(currentPoint3D,newPoint3D,-1.0)==false){
					//tB[h̊Oɏo邩玸s
					//邢̓m[hƃm[h̊Ԃ̎}Ԃ邩玸s
					//̎}ĥȂ
					for(int t=0;t!=1 && index < length ;++index){
						switch(ABuffer.GetAt(index)){
						case '(':
							--t;
							break;
						case ')':
							++t;
							break;
						}
					}
					delete newPoint3D;
					break;
				}
#endif
				//܂łŁA}ĂƂ
				mEdge* newEdge = new mEdge(seed,currentPoint3D,newPoint3D);
				edgeList->push_back(newEdge);
				//݂̃|CgX^bNɂł
				pointStack.push(currentPoint3D);
				currentPoint3D=newPoint3D;
				break;
			}
		case '(':
			//ɂ邱Ɩ
			break;
		case ')':
			//X^bN|Cg߂
			currentPoint3D=pointStack.top();
			pointStack.pop();
			break;
		default:
			// ɂƂ͉̂
			ASSERT(0);
			throw "";
			break;
		}// end of switch
	} // end of while
	//X^bN̒g͂̂߂ǂdeleteȂ
}

template<class T>
static mDouble getPartsVolume(vector<T*>* pList)
{
	mDouble returnValue=0.0;
	if(pList){
		for(vector<T*>::iterator it = pList->begin();
				it!=pList->end();++it){
			returnValue+=(*it)->getVolume();
		}
	}
	return returnValue;
}	

template<class T>
static mDouble getPartsCalorie(vector<T*>* pList)
{
	mDouble returnValue=0.0;
	if(pList){
		for(vector<T*>::iterator it = pList->begin();
				it!=pList->end();++it){
			returnValue+=(*it)->getCalorie();
		}
	}
	return returnValue;
}	

mDouble mPartsList::getFlowerVolume()
{
	return getPartsVolume<mFlower>(flowerList);
}

mDouble mPartsList::getLeafVolume()
{
	return getPartsVolume<mLeaf>(leafList);
}

mDouble mPartsList::getEdgeVolume()
{
	return getPartsVolume<mEdge>(edgeList);
}

mDouble mPartsList::getFlowerCalorie()
{
	return getPartsCalorie<mFlower>(flowerList);
}

mDouble mPartsList::getLeafCalorie()
{
	return getPartsCalorie<mLeaf>(leafList);
}

mDouble mPartsList::getEdgeCalorie()
{
	return getPartsCalorie<mEdge>(edgeList);
}

mDouble mPartsList::getVolume()
{
	//ׂĂ̗vf̑̐ς
	return getFlowerVolume()+getLeafVolume()
					+getEdgeVolume()+mParameter::mSeed_volume;
}

mDouble mPartsList::getCalorie()
{
	//ׂĂ̗vf̑̐ςɒPʑ̐ς̃J[̂
	return getFlowerCalorie()+getLeafCalorie()
		+getEdgeCalorie()+mParameter::mSeed_calorie;
}

mDouble mPartsList::aggregateEnergy()
{
	return aggregateEnergyValue;
}

mDouble mPartsList::aggregateFlowerEnergy()
{
	return aggregateEnergyFlower;
}

template<class T>
static void freePartsList(vector<T*>* pList)
{
	if(pList!=NULL){
		for(vector<T*>::iterator it=pList->begin();
		it!=pList->end();++it){
			if(*it){
				delete *it;
				*it=NULL;
			}
		}
		pList->clear();
		delete pList;
	}
}

void mPartsList::freeList()
{
	//Ђ烊XgĂ
	freePartsList<mFlower>(flowerList);
	flowerList=NULL;
	freePartsList<mLeaf>(leafList);
	leafList=NULL;
	freePartsList<mNode>(nodeList);
	nodeList=NULL;
	freePartsList<mEdge>(edgeList);
	edgeList=NULL;
}

mPoint3D* mPartsList::makePoint3D(mDouble r, mDouble theta, mDouble phy)
{
	mPoint3D* point = new mPoint3D;
		/*̃|C^͂ǂł
		delete邱ƁB
		*/
	point->x=r*sin(theta)*cos(phy);
	point->y=r*sin(theta)*sin(phy);
	point->z=r*cos(theta);
	return point;
}

mFlower* mPartsList::getFlower(mInt index)
{
	if(flowerList){
		if(index<0||index>=flowerList->size()){
			//indexčȂ
			return NULL;
		}
		return *(flowerList->begin()+index);
	}
	return NULL; //ǎs
}

void mPartsList::calculateAggregateEnergy()
{
	aggregateEnergyValue=0.0;
	if(leafList){
		for(vector<mLeaf*>::iterator itLeaf = leafList->begin();
				itLeaf!=leafList->end();++itLeaf){
			aggregateEnergyValue+=(*itLeaf)->getLightEnergy();
		}
	}

}

void mPartsList::calculateAggregateFlowerEnergy()
{
	aggregateEnergyFlower=0.0;
	if(flowerList){
		for(vector<mFlower*>::iterator itFlower = flowerList->begin();
				itFlower!=flowerList->end();++itFlower){
			aggregateEnergyFlower+=(*itFlower)->getLightEnergy();
		}
	}
}

bool mPartsList::canMake(mPoint3D *otherCenterPoint3D, mPoint3D *otherEndPoint3D, mDouble radius)
{

	//otherCenterPoint3DNULL̂ƂcanMakeEdgeׂ͒Ȃ
	if(otherCenterPoint3D != NULL){
		//ŁAm[hƉԂȂ}ɂԂ邩𒲂ׂĂ
		if(seed->getSeedList()){
			if(seed->getSeedList()->canMakeEdge(otherCenterPoint3D,otherEndPoint3D)==false){
			//}̂ɂԂ邩玸s
				return false;
			}
		}else{
			//Ƃ肠seedListɂȂĂȂ
			//̃V[hŔf
			if(canMakeEdge(otherCenterPoint3D,otherEndPoint3D)==false){
			//}̂ɂԂ邩玸s
				return false;
			}
		}
	}

	if(radius<=0.0){
		//a0.0͍̋ĂԂȂ
		return true;
	}

	if(otherEndPoint3D->z < radius){
		//nʂɂԂĂ
		return false;
	}

	if(seed->getSeedList()){
		if(seed->getSeedList()->canMakeBowl(otherEndPoint3D,radius)==false){
		//̂ɂԂ邩玸s
			return false;
		}
	}else{
		//Ƃ肠seedListɂȂĂȂ
		//̃V[hŔf
		if(canMakeBowl(otherEndPoint3D,radius)==false){
		//̂ɂԂ邩玸s
			return false;
		}
	}
	return true;
	//܂ł΂ԂĂȂ
}

mInt mPartsList::searchIndex(const char targetChar, const mInt targetNumber)
{
	//ł͍ŏtargetChar̕targetNumber==0ł
	const length = ABuffer.GetLength();
	mInt searchNumber = 0;
	for(mInt index = 0;index < length; ++index){
		if(ABuffer.GetAt(index)==targetChar){
			if(searchNumber == targetNumber){
				//ŌƂ
				return index;
			}
			++searchNumber;
		}
	}
	return length; //s炱Ԃ
}

mInt mPartsList::countChar(const char targetChar,const  mInt endIndex)
{
	mInt returnValue = 0;
	const mInt length = min(endIndex,ABuffer.GetLength());
	for(mInt index = 0; index < length;++index){
		if(ABuffer.GetAt(index)==targetChar){
			//̂̂Ƃ
			++returnValue;
		}
	}
	return returnValue;
}

void mPartsList::cutStringRadius(const mInt index)
{
	mInt endIndex;
	for(endIndex = index ; endIndex < ABuffer.GetLength(); ++endIndex){
		if(ABuffer.GetAt(endIndex)=='>'){
			ABuffer.Delete(index,endIndex-index+1);
			return;
		}
	}
}

mPartsList::mPartsList(mSeed *seed)
{
	this->seed=seed;
	ABuffer="";
	flowerList=NULL;
	leafList=NULL;
	nodeList=NULL;
	edgeList=NULL;
	aggregateEnergyFlower = 0.0;
	aggregateEnergyValue = 0.0;

}

CString mPartsList::getABuffer()
{
	return ABuffer;
}

void mPartsList::saveBirdView(ostream& os)
{
	if(edgeList){
		for(vector<mEdge*>::iterator it = edgeList->begin();
				it != edgeList->end();
				++it){
			if(*it){
				os << (*it)->toString() <<endl;
			}
		}
	}

	if(leafList){
		for(vector<mLeaf*>::iterator it = leafList->begin();
				it != leafList->end();
				++it){
			if(*it){
				os << (*it)->toString() <<endl;
			}
		}
	}
	if(flowerList){
		for(vector<mFlower*>::iterator it = flowerList->begin();
				it != flowerList->end();
				++it){
			if(*it){
				os << (*it)->toString() <<endl;
			}
		}
	}
/*	if(nodeList){
		for(vector<mNode*>::iterator it = nodeList->begin();
				it != nodeList->end();
				++it){
			if(*it){
				os << (*it)->toString() <<endl;
			}
		}
	}
*/
}

template<class T>
static mDouble getPartsKeepCalorie(vector<T*>* pList)
{
	mDouble returnValue=0.0;
	if(pList){
		for(vector<T*>::iterator it = pList->begin();
				it!=pList->end();++it){
			returnValue+=(*it)->getKeepCalorie();
		}
	}
	return returnValue;
}	

mDouble mPartsList::getFlowerKeepCalorie()
{
	return getPartsKeepCalorie<mFlower>(flowerList);
}

mDouble mPartsList::getLeafKeepCalorie()
{
	return getPartsKeepCalorie<mLeaf>(leafList);
}

mDouble mPartsList::getEdgeKeepCalorie()
{
	return getPartsKeepCalorie<mEdge>(edgeList);
}

mDouble mPartsList::getKeepCalorie()
{
	return getFlowerKeepCalorie()+getLeafKeepCalorie()
		+getEdgeKeepCalorie()+mParameter::mSeed_keep_calorie;

}

bool mPartsList::check_energy(mDouble r, mDouble energy)
{
	if(r < mParameter::mSeedList_min_r && r >= 0.0){
		//܂ɒZ}͍点Ȃ
		return false;
	}

	mDouble edge_calorie = mEdge::calculateCalorie(r);
	mDouble edge_keep_calorie = edge_calorie * mParameter::mEdge_keep_calorie ;
	mDouble estimate_total_energy = edge_calorie + edge_keep_calorie + energy;

	if(estimate_total_energy > mParameter::mPartsList_tolerance_energy
				* seed->getCPU()->getEnergy()->getCurrentEnergy()
				&& seed->getSeedList() != NULL){
		//܂ɖdȂƂ͂Ȃ悤ɂ
		// NULLƂ̔rkTargetgene̕\̂Ƃ̂
		return false;
	}
	return true; //ȂĂv
}

bool mPartsList::check_energy(mDouble energy)
{

	if(energy > mParameter::mPartsList_tolerance_energy
				* seed->getCPU()->getEnergy()->getCurrentEnergy()
				&& seed->getSeedList() != NULL){
		//܂ɖdȂƂ͂Ȃ悤ɂ
		// NULLƂ̔rkTargetgene̕\̂Ƃ̂
		return false;
	}
	return true; //ȂĂv
}
